import React, { createContext, forwardRef, createElement, Component, Fragment } from 'react';
import PropTypes from 'prop-types';

var config = {
  ACCESS_TOKEN: 'b800ec60adc0c22e08aabd4b0d18280f652b19e5ad2c157593bceb9b811fcd6b',
  SPACE_ID: 'w6rcgw8h8anz'
};

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

var defineProperty = _defineProperty;

function memoize(fn) {
  var cache = {};
  return function (arg) {
    if (cache[arg] === undefined) cache[arg] = fn(arg);
    return cache[arg];
  };
}

var reactPropsRegex = /^((children|dangerouslySetInnerHTML|key|ref|autoFocus|defaultValue|defaultChecked|innerHTML|suppressContentEditableWarning|suppressHydrationWarning|valueLink|accept|acceptCharset|accessKey|action|allow|allowUserMedia|allowPaymentRequest|allowFullScreen|allowTransparency|alt|async|autoComplete|autoPlay|capture|cellPadding|cellSpacing|challenge|charSet|checked|cite|classID|className|cols|colSpan|content|contentEditable|contextMenu|controls|controlsList|coords|crossOrigin|data|dateTime|decoding|default|defer|dir|disabled|download|draggable|encType|form|formAction|formEncType|formMethod|formNoValidate|formTarget|frameBorder|headers|height|hidden|high|href|hrefLang|htmlFor|httpEquiv|id|inputMode|integrity|is|keyParams|keyType|kind|label|lang|list|loading|loop|low|marginHeight|marginWidth|max|maxLength|media|mediaGroup|method|min|minLength|multiple|muted|name|nonce|noValidate|open|optimum|pattern|placeholder|playsInline|poster|preload|profile|radioGroup|readOnly|referrerPolicy|rel|required|reversed|role|rows|rowSpan|sandbox|scope|scoped|scrolling|seamless|selected|shape|size|sizes|slot|span|spellCheck|src|srcDoc|srcLang|srcSet|start|step|style|summary|tabIndex|target|title|type|useMap|value|width|wmode|wrap|about|datatype|inlist|prefix|property|resource|typeof|vocab|autoCapitalize|autoCorrect|autoSave|color|itemProp|itemScope|itemType|itemID|itemRef|results|security|unselectable|accentHeight|accumulate|additive|alignmentBaseline|allowReorder|alphabetic|amplitude|arabicForm|ascent|attributeName|attributeType|autoReverse|azimuth|baseFrequency|baselineShift|baseProfile|bbox|begin|bias|by|calcMode|capHeight|clip|clipPathUnits|clipPath|clipRule|colorInterpolation|colorInterpolationFilters|colorProfile|colorRendering|contentScriptType|contentStyleType|cursor|cx|cy|d|decelerate|descent|diffuseConstant|direction|display|divisor|dominantBaseline|dur|dx|dy|edgeMode|elevation|enableBackground|end|exponent|externalResourcesRequired|fill|fillOpacity|fillRule|filter|filterRes|filterUnits|floodColor|floodOpacity|focusable|fontFamily|fontSize|fontSizeAdjust|fontStretch|fontStyle|fontVariant|fontWeight|format|from|fr|fx|fy|g1|g2|glyphName|glyphOrientationHorizontal|glyphOrientationVertical|glyphRef|gradientTransform|gradientUnits|hanging|horizAdvX|horizOriginX|ideographic|imageRendering|in|in2|intercept|k|k1|k2|k3|k4|kernelMatrix|kernelUnitLength|kerning|keyPoints|keySplines|keyTimes|lengthAdjust|letterSpacing|lightingColor|limitingConeAngle|local|markerEnd|markerMid|markerStart|markerHeight|markerUnits|markerWidth|mask|maskContentUnits|maskUnits|mathematical|mode|numOctaves|offset|opacity|operator|order|orient|orientation|origin|overflow|overlinePosition|overlineThickness|panose1|paintOrder|pathLength|patternContentUnits|patternTransform|patternUnits|pointerEvents|points|pointsAtX|pointsAtY|pointsAtZ|preserveAlpha|preserveAspectRatio|primitiveUnits|r|radius|refX|refY|renderingIntent|repeatCount|repeatDur|requiredExtensions|requiredFeatures|restart|result|rotate|rx|ry|scale|seed|shapeRendering|slope|spacing|specularConstant|specularExponent|speed|spreadMethod|startOffset|stdDeviation|stemh|stemv|stitchTiles|stopColor|stopOpacity|strikethroughPosition|strikethroughThickness|string|stroke|strokeDasharray|strokeDashoffset|strokeLinecap|strokeLinejoin|strokeMiterlimit|strokeOpacity|strokeWidth|surfaceScale|systemLanguage|tableValues|targetX|targetY|textAnchor|textDecoration|textRendering|textLength|to|transform|u1|u2|underlinePosition|underlineThickness|unicode|unicodeBidi|unicodeRange|unitsPerEm|vAlphabetic|vHanging|vIdeographic|vMathematical|values|vectorEffect|version|vertAdvY|vertOriginX|vertOriginY|viewBox|viewTarget|visibility|widths|wordSpacing|writingMode|x|xHeight|x1|x2|xChannelSelector|xlinkActuate|xlinkArcrole|xlinkHref|xlinkRole|xlinkShow|xlinkTitle|xlinkType|xmlBase|xmlns|xmlnsXlink|xmlLang|xmlSpace|y|y1|y2|yChannelSelector|z|zoomAndPan|for|class|autofocus)|(([Dd][Aa][Tt][Aa]|[Aa][Rr][Ii][Aa]|x)-.*))$/; // https://esbench.com/bench/5bfee68a4cd7e6009ef61d23

var index = memoize(function (prop) {
  return reactPropsRegex.test(prop) || prop.charCodeAt(0) === 111
  /* o */
  && prop.charCodeAt(1) === 110
  /* n */
  && prop.charCodeAt(2) < 91;
}
/* Z+1 */
);

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}

var inheritsLoose = _inheritsLoose;

/*

Based off glamor's StyleSheet, thanks Sunil ❤️

high performance StyleSheet for css-in-js systems

- uses multiple style tags behind the scenes for millions of rules
- uses `insertRule` for appending in production for *much* faster performance

// usage

import { StyleSheet } from '@emotion/sheet'

let styleSheet = new StyleSheet({ key: '', container: document.head })

styleSheet.insert('#box { border: 1px solid red; }')
- appends a css rule into the stylesheet

styleSheet.flush()
- empties the stylesheet of all its contents

*/
// $FlowFixMe
function sheetForTag(tag) {
  if (tag.sheet) {
    // $FlowFixMe
    return tag.sheet;
  } // this weirdness brought to you by firefox

  /* istanbul ignore next */


  for (var i = 0; i < document.styleSheets.length; i++) {
    if (document.styleSheets[i].ownerNode === tag) {
      // $FlowFixMe
      return document.styleSheets[i];
    }
  }
}

function createStyleElement(options) {
  var tag = document.createElement('style');
  tag.setAttribute('data-emotion', options.key);

  if (options.nonce !== undefined) {
    tag.setAttribute('nonce', options.nonce);
  }

  tag.appendChild(document.createTextNode(''));
  return tag;
}

var StyleSheet =
/*#__PURE__*/
function () {
  function StyleSheet(options) {
    this.isSpeedy = options.speedy === undefined ? process.env.NODE_ENV === 'production' : options.speedy;
    this.tags = [];
    this.ctr = 0;
    this.nonce = options.nonce; // key is the value of the data-emotion attribute, it's used to identify different sheets

    this.key = options.key;
    this.container = options.container;
    this.before = null;
  }

  var _proto = StyleSheet.prototype;

  _proto.insert = function insert(rule) {
    // the max length is how many rules we have per style tag, it's 65000 in speedy mode
    // it's 1 in dev because we insert source maps that map a single rule to a location
    // and you can only have one source map per style tag
    if (this.ctr % (this.isSpeedy ? 65000 : 1) === 0) {
      var _tag = createStyleElement(this);

      var before;

      if (this.tags.length === 0) {
        before = this.before;
      } else {
        before = this.tags[this.tags.length - 1].nextSibling;
      }

      this.container.insertBefore(_tag, before);
      this.tags.push(_tag);
    }

    var tag = this.tags[this.tags.length - 1];

    if (this.isSpeedy) {
      var sheet = sheetForTag(tag);

      try {
        // this is a really hot path
        // we check the second character first because having "i"
        // as the second character will happen less often than
        // having "@" as the first character
        var isImportRule = rule.charCodeAt(1) === 105 && rule.charCodeAt(0) === 64; // this is the ultrafast version, works across browsers
        // the big drawback is that the css won't be editable in devtools

        sheet.insertRule(rule, // we need to insert @import rules before anything else
        // otherwise there will be an error
        // technically this means that the @import rules will
        // _usually_(not always since there could be multiple style tags)
        // be the first ones in prod and generally later in dev
        // this shouldn't really matter in the real world though
        // @import is generally only used for font faces from google fonts and etc.
        // so while this could be technically correct then it would be slower and larger
        // for a tiny bit of correctness that won't matter in the real world
        isImportRule ? 0 : sheet.cssRules.length);
      } catch (e) {
        if (process.env.NODE_ENV !== 'production') {
          console.warn("There was a problem inserting the following rule: \"" + rule + "\"", e);
        }
      }
    } else {
      tag.appendChild(document.createTextNode(rule));
    }

    this.ctr++;
  };

  _proto.flush = function flush() {
    // $FlowFixMe
    this.tags.forEach(function (tag) {
      return tag.parentNode.removeChild(tag);
    });
    this.tags = [];
    this.ctr = 0;
  };

  return StyleSheet;
}();

function stylis_min (W) {
  function M(d, c, e, h, a) {
    for (var m = 0, b = 0, v = 0, n = 0, q, g, x = 0, K = 0, k, u = k = q = 0, l = 0, r = 0, I = 0, t = 0, B = e.length, J = B - 1, y, f = '', p = '', F = '', G = '', C; l < B;) {
      g = e.charCodeAt(l);
      l === J && 0 !== b + n + v + m && (0 !== b && (g = 47 === b ? 10 : 47), n = v = m = 0, B++, J++);

      if (0 === b + n + v + m) {
        if (l === J && (0 < r && (f = f.replace(N, '')), 0 < f.trim().length)) {
          switch (g) {
            case 32:
            case 9:
            case 59:
            case 13:
            case 10:
              break;

            default:
              f += e.charAt(l);
          }

          g = 59;
        }

        switch (g) {
          case 123:
            f = f.trim();
            q = f.charCodeAt(0);
            k = 1;

            for (t = ++l; l < B;) {
              switch (g = e.charCodeAt(l)) {
                case 123:
                  k++;
                  break;

                case 125:
                  k--;
                  break;

                case 47:
                  switch (g = e.charCodeAt(l + 1)) {
                    case 42:
                    case 47:
                      a: {
                        for (u = l + 1; u < J; ++u) {
                          switch (e.charCodeAt(u)) {
                            case 47:
                              if (42 === g && 42 === e.charCodeAt(u - 1) && l + 2 !== u) {
                                l = u + 1;
                                break a;
                              }

                              break;

                            case 10:
                              if (47 === g) {
                                l = u + 1;
                                break a;
                              }

                          }
                        }

                        l = u;
                      }

                  }

                  break;

                case 91:
                  g++;

                case 40:
                  g++;

                case 34:
                case 39:
                  for (; l++ < J && e.charCodeAt(l) !== g;) {
                  }

              }

              if (0 === k) break;
              l++;
            }

            k = e.substring(t, l);
            0 === q && (q = (f = f.replace(ca, '').trim()).charCodeAt(0));

            switch (q) {
              case 64:
                0 < r && (f = f.replace(N, ''));
                g = f.charCodeAt(1);

                switch (g) {
                  case 100:
                  case 109:
                  case 115:
                  case 45:
                    r = c;
                    break;

                  default:
                    r = O;
                }

                k = M(c, r, k, g, a + 1);
                t = k.length;
                0 < A && (r = X(O, f, I), C = H(3, k, r, c, D, z, t, g, a, h), f = r.join(''), void 0 !== C && 0 === (t = (k = C.trim()).length) && (g = 0, k = ''));
                if (0 < t) switch (g) {
                  case 115:
                    f = f.replace(da, ea);

                  case 100:
                  case 109:
                  case 45:
                    k = f + '{' + k + '}';
                    break;

                  case 107:
                    f = f.replace(fa, '$1 $2');
                    k = f + '{' + k + '}';
                    k = 1 === w || 2 === w && L('@' + k, 3) ? '@-webkit-' + k + '@' + k : '@' + k;
                    break;

                  default:
                    k = f + k, 112 === h && (k = (p += k, ''));
                } else k = '';
                break;

              default:
                k = M(c, X(c, f, I), k, h, a + 1);
            }

            F += k;
            k = I = r = u = q = 0;
            f = '';
            g = e.charCodeAt(++l);
            break;

          case 125:
          case 59:
            f = (0 < r ? f.replace(N, '') : f).trim();
            if (1 < (t = f.length)) switch (0 === u && (q = f.charCodeAt(0), 45 === q || 96 < q && 123 > q) && (t = (f = f.replace(' ', ':')).length), 0 < A && void 0 !== (C = H(1, f, c, d, D, z, p.length, h, a, h)) && 0 === (t = (f = C.trim()).length) && (f = '\x00\x00'), q = f.charCodeAt(0), g = f.charCodeAt(1), q) {
              case 0:
                break;

              case 64:
                if (105 === g || 99 === g) {
                  G += f + e.charAt(l);
                  break;
                }

              default:
                58 !== f.charCodeAt(t - 1) && (p += P(f, q, g, f.charCodeAt(2)));
            }
            I = r = u = q = 0;
            f = '';
            g = e.charCodeAt(++l);
        }
      }

      switch (g) {
        case 13:
        case 10:
          47 === b ? b = 0 : 0 === 1 + q && 107 !== h && 0 < f.length && (r = 1, f += '\x00');
          0 < A * Y && H(0, f, c, d, D, z, p.length, h, a, h);
          z = 1;
          D++;
          break;

        case 59:
        case 125:
          if (0 === b + n + v + m) {
            z++;
            break;
          }

        default:
          z++;
          y = e.charAt(l);

          switch (g) {
            case 9:
            case 32:
              if (0 === n + m + b) switch (x) {
                case 44:
                case 58:
                case 9:
                case 32:
                  y = '';
                  break;

                default:
                  32 !== g && (y = ' ');
              }
              break;

            case 0:
              y = '\\0';
              break;

            case 12:
              y = '\\f';
              break;

            case 11:
              y = '\\v';
              break;

            case 38:
              0 === n + b + m && (r = I = 1, y = '\f' + y);
              break;

            case 108:
              if (0 === n + b + m + E && 0 < u) switch (l - u) {
                case 2:
                  112 === x && 58 === e.charCodeAt(l - 3) && (E = x);

                case 8:
                  111 === K && (E = K);
              }
              break;

            case 58:
              0 === n + b + m && (u = l);
              break;

            case 44:
              0 === b + v + n + m && (r = 1, y += '\r');
              break;

            case 34:
            case 39:
              0 === b && (n = n === g ? 0 : 0 === n ? g : n);
              break;

            case 91:
              0 === n + b + v && m++;
              break;

            case 93:
              0 === n + b + v && m--;
              break;

            case 41:
              0 === n + b + m && v--;
              break;

            case 40:
              if (0 === n + b + m) {
                if (0 === q) switch (2 * x + 3 * K) {
                  case 533:
                    break;

                  default:
                    q = 1;
                }
                v++;
              }

              break;

            case 64:
              0 === b + v + n + m + u + k && (k = 1);
              break;

            case 42:
            case 47:
              if (!(0 < n + m + v)) switch (b) {
                case 0:
                  switch (2 * g + 3 * e.charCodeAt(l + 1)) {
                    case 235:
                      b = 47;
                      break;

                    case 220:
                      t = l, b = 42;
                  }

                  break;

                case 42:
                  47 === g && 42 === x && t + 2 !== l && (33 === e.charCodeAt(t + 2) && (p += e.substring(t, l + 1)), y = '', b = 0);
              }
          }

          0 === b && (f += y);
      }

      K = x;
      x = g;
      l++;
    }

    t = p.length;

    if (0 < t) {
      r = c;
      if (0 < A && (C = H(2, p, r, d, D, z, t, h, a, h), void 0 !== C && 0 === (p = C).length)) return G + p + F;
      p = r.join(',') + '{' + p + '}';

      if (0 !== w * E) {
        2 !== w || L(p, 2) || (E = 0);

        switch (E) {
          case 111:
            p = p.replace(ha, ':-moz-$1') + p;
            break;

          case 112:
            p = p.replace(Q, '::-webkit-input-$1') + p.replace(Q, '::-moz-$1') + p.replace(Q, ':-ms-input-$1') + p;
        }

        E = 0;
      }
    }

    return G + p + F;
  }

  function X(d, c, e) {
    var h = c.trim().split(ia);
    c = h;
    var a = h.length,
        m = d.length;

    switch (m) {
      case 0:
      case 1:
        var b = 0;

        for (d = 0 === m ? '' : d[0] + ' '; b < a; ++b) {
          c[b] = Z(d, c[b], e).trim();
        }

        break;

      default:
        var v = b = 0;

        for (c = []; b < a; ++b) {
          for (var n = 0; n < m; ++n) {
            c[v++] = Z(d[n] + ' ', h[b], e).trim();
          }
        }

    }

    return c;
  }

  function Z(d, c, e) {
    var h = c.charCodeAt(0);
    33 > h && (h = (c = c.trim()).charCodeAt(0));

    switch (h) {
      case 38:
        return c.replace(F, '$1' + d.trim());

      case 58:
        return d.trim() + c.replace(F, '$1' + d.trim());

      default:
        if (0 < 1 * e && 0 < c.indexOf('\f')) return c.replace(F, (58 === d.charCodeAt(0) ? '' : '$1') + d.trim());
    }

    return d + c;
  }

  function P(d, c, e, h) {
    var a = d + ';',
        m = 2 * c + 3 * e + 4 * h;

    if (944 === m) {
      d = a.indexOf(':', 9) + 1;
      var b = a.substring(d, a.length - 1).trim();
      b = a.substring(0, d).trim() + b + ';';
      return 1 === w || 2 === w && L(b, 1) ? '-webkit-' + b + b : b;
    }

    if (0 === w || 2 === w && !L(a, 1)) return a;

    switch (m) {
      case 1015:
        return 97 === a.charCodeAt(10) ? '-webkit-' + a + a : a;

      case 951:
        return 116 === a.charCodeAt(3) ? '-webkit-' + a + a : a;

      case 963:
        return 110 === a.charCodeAt(5) ? '-webkit-' + a + a : a;

      case 1009:
        if (100 !== a.charCodeAt(4)) break;

      case 969:
      case 942:
        return '-webkit-' + a + a;

      case 978:
        return '-webkit-' + a + '-moz-' + a + a;

      case 1019:
      case 983:
        return '-webkit-' + a + '-moz-' + a + '-ms-' + a + a;

      case 883:
        if (45 === a.charCodeAt(8)) return '-webkit-' + a + a;
        if (0 < a.indexOf('image-set(', 11)) return a.replace(ja, '$1-webkit-$2') + a;
        break;

      case 932:
        if (45 === a.charCodeAt(4)) switch (a.charCodeAt(5)) {
          case 103:
            return '-webkit-box-' + a.replace('-grow', '') + '-webkit-' + a + '-ms-' + a.replace('grow', 'positive') + a;

          case 115:
            return '-webkit-' + a + '-ms-' + a.replace('shrink', 'negative') + a;

          case 98:
            return '-webkit-' + a + '-ms-' + a.replace('basis', 'preferred-size') + a;
        }
        return '-webkit-' + a + '-ms-' + a + a;

      case 964:
        return '-webkit-' + a + '-ms-flex-' + a + a;

      case 1023:
        if (99 !== a.charCodeAt(8)) break;
        b = a.substring(a.indexOf(':', 15)).replace('flex-', '').replace('space-between', 'justify');
        return '-webkit-box-pack' + b + '-webkit-' + a + '-ms-flex-pack' + b + a;

      case 1005:
        return ka.test(a) ? a.replace(aa, ':-webkit-') + a.replace(aa, ':-moz-') + a : a;

      case 1e3:
        b = a.substring(13).trim();
        c = b.indexOf('-') + 1;

        switch (b.charCodeAt(0) + b.charCodeAt(c)) {
          case 226:
            b = a.replace(G, 'tb');
            break;

          case 232:
            b = a.replace(G, 'tb-rl');
            break;

          case 220:
            b = a.replace(G, 'lr');
            break;

          default:
            return a;
        }

        return '-webkit-' + a + '-ms-' + b + a;

      case 1017:
        if (-1 === a.indexOf('sticky', 9)) break;

      case 975:
        c = (a = d).length - 10;
        b = (33 === a.charCodeAt(c) ? a.substring(0, c) : a).substring(d.indexOf(':', 7) + 1).trim();

        switch (m = b.charCodeAt(0) + (b.charCodeAt(7) | 0)) {
          case 203:
            if (111 > b.charCodeAt(8)) break;

          case 115:
            a = a.replace(b, '-webkit-' + b) + ';' + a;
            break;

          case 207:
          case 102:
            a = a.replace(b, '-webkit-' + (102 < m ? 'inline-' : '') + 'box') + ';' + a.replace(b, '-webkit-' + b) + ';' + a.replace(b, '-ms-' + b + 'box') + ';' + a;
        }

        return a + ';';

      case 938:
        if (45 === a.charCodeAt(5)) switch (a.charCodeAt(6)) {
          case 105:
            return b = a.replace('-items', ''), '-webkit-' + a + '-webkit-box-' + b + '-ms-flex-' + b + a;

          case 115:
            return '-webkit-' + a + '-ms-flex-item-' + a.replace(ba, '') + a;

          default:
            return '-webkit-' + a + '-ms-flex-line-pack' + a.replace('align-content', '').replace(ba, '') + a;
        }
        break;

      case 973:
      case 989:
        if (45 !== a.charCodeAt(3) || 122 === a.charCodeAt(4)) break;

      case 931:
      case 953:
        if (!0 === la.test(d)) return 115 === (b = d.substring(d.indexOf(':') + 1)).charCodeAt(0) ? P(d.replace('stretch', 'fill-available'), c, e, h).replace(':fill-available', ':stretch') : a.replace(b, '-webkit-' + b) + a.replace(b, '-moz-' + b.replace('fill-', '')) + a;
        break;

      case 962:
        if (a = '-webkit-' + a + (102 === a.charCodeAt(5) ? '-ms-' + a : '') + a, 211 === e + h && 105 === a.charCodeAt(13) && 0 < a.indexOf('transform', 10)) return a.substring(0, a.indexOf(';', 27) + 1).replace(ma, '$1-webkit-$2') + a;
    }

    return a;
  }

  function L(d, c) {
    var e = d.indexOf(1 === c ? ':' : '{'),
        h = d.substring(0, 3 !== c ? e : 10);
    e = d.substring(e + 1, d.length - 1);
    return R(2 !== c ? h : h.replace(na, '$1'), e, c);
  }

  function ea(d, c) {
    var e = P(c, c.charCodeAt(0), c.charCodeAt(1), c.charCodeAt(2));
    return e !== c + ';' ? e.replace(oa, ' or ($1)').substring(4) : '(' + c + ')';
  }

  function H(d, c, e, h, a, m, b, v, n, q) {
    for (var g = 0, x = c, w; g < A; ++g) {
      switch (w = S[g].call(B, d, x, e, h, a, m, b, v, n, q)) {
        case void 0:
        case !1:
        case !0:
        case null:
          break;

        default:
          x = w;
      }
    }

    if (x !== c) return x;
  }

  function T(d) {
    switch (d) {
      case void 0:
      case null:
        A = S.length = 0;
        break;

      default:
        if ('function' === typeof d) S[A++] = d;else if ('object' === typeof d) for (var c = 0, e = d.length; c < e; ++c) {
          T(d[c]);
        } else Y = !!d | 0;
    }

    return T;
  }

  function U(d) {
    d = d.prefix;
    void 0 !== d && (R = null, d ? 'function' !== typeof d ? w = 1 : (w = 2, R = d) : w = 0);
    return U;
  }

  function B(d, c) {
    var e = d;
    33 > e.charCodeAt(0) && (e = e.trim());
    V = e;
    e = [V];

    if (0 < A) {
      var h = H(-1, c, e, e, D, z, 0, 0, 0, 0);
      void 0 !== h && 'string' === typeof h && (c = h);
    }

    var a = M(O, e, c, 0, 0);
    0 < A && (h = H(-2, a, e, e, D, z, a.length, 0, 0, 0), void 0 !== h && (a = h));
    V = '';
    E = 0;
    z = D = 1;
    return a;
  }

  var ca = /^\0+/g,
      N = /[\0\r\f]/g,
      aa = /: */g,
      ka = /zoo|gra/,
      ma = /([,: ])(transform)/g,
      ia = /,\r+?/g,
      F = /([\t\r\n ])*\f?&/g,
      fa = /@(k\w+)\s*(\S*)\s*/,
      Q = /::(place)/g,
      ha = /:(read-only)/g,
      G = /[svh]\w+-[tblr]{2}/,
      da = /\(\s*(.*)\s*\)/g,
      oa = /([\s\S]*?);/g,
      ba = /-self|flex-/g,
      na = /[^]*?(:[rp][el]a[\w-]+)[^]*/,
      la = /stretch|:\s*\w+\-(?:conte|avail)/,
      ja = /([^-])(image-set\()/,
      z = 1,
      D = 1,
      E = 0,
      w = 1,
      O = [],
      S = [],
      A = 0,
      R = null,
      Y = 0,
      V = '';
  B.use = T;
  B.set = U;
  void 0 !== W && U(W);
  return B;
}

var weakMemoize = function weakMemoize(func) {
  // $FlowFixMe flow doesn't include all non-primitive types as allowed for weakmaps
  var cache = new WeakMap();
  return function (arg) {
    if (cache.has(arg)) {
      // $FlowFixMe
      return cache.get(arg);
    }

    var ret = func(arg);
    cache.set(arg, ret);
    return ret;
  };
};

// https://github.com/thysultan/stylis.js/tree/master/plugins/rule-sheet
// inlined to avoid umd wrapper and peerDep warnings/installing stylis
// since we use stylis after closure compiler
var delimiter = '/*|*/';
var needle = delimiter + '}';

function toSheet(block) {
  if (block) {
    Sheet.current.insert(block + '}');
  }
}

var Sheet = {
  current: null
};
var ruleSheet = function ruleSheet(context, content, selectors, parents, line, column, length, ns, depth, at) {
  switch (context) {
    // property
    case 1:
      {
        switch (content.charCodeAt(0)) {
          case 64:
            {
              // @import
              Sheet.current.insert(content + ';');
              return '';
            }
          // charcode for l

          case 108:
            {
              // charcode for b
              // this ignores label
              if (content.charCodeAt(2) === 98) {
                return '';
              }
            }
        }

        break;
      }
    // selector

    case 2:
      {
        if (ns === 0) return content + delimiter;
        break;
      }
    // at-rule

    case 3:
      {
        switch (ns) {
          // @font-face, @page
          case 102:
          case 112:
            {
              Sheet.current.insert(selectors[0] + content);
              return '';
            }

          default:
            {
              return content + (at === 0 ? delimiter : '');
            }
        }
      }

    case -2:
      {
        content.split(needle).forEach(toSheet);
      }
  }
};
var removeLabel = function removeLabel(context, content) {
  if (context === 1 && // charcode for l
  content.charCodeAt(0) === 108 && // charcode for b
  content.charCodeAt(2) === 98 // this ignores label
  ) {
      return '';
    }
};

var isBrowser = typeof document !== 'undefined';
var rootServerStylisCache = {};
var getServerStylisCache = isBrowser ? undefined : weakMemoize(function () {
  var getCache = weakMemoize(function () {
    return {};
  });
  var prefixTrueCache = {};
  var prefixFalseCache = {};
  return function (prefix) {
    if (prefix === undefined || prefix === true) {
      return prefixTrueCache;
    }

    if (prefix === false) {
      return prefixFalseCache;
    }

    return getCache(prefix);
  };
});

var createCache = function createCache(options) {
  if (options === undefined) options = {};
  var key = options.key || 'css';
  var stylisOptions;

  if (options.prefix !== undefined) {
    stylisOptions = {
      prefix: options.prefix
    };
  }

  var stylis = new stylis_min(stylisOptions);

  if (process.env.NODE_ENV !== 'production') {
    // $FlowFixMe
    if (/[^a-z-]/.test(key)) {
      throw new Error("Emotion key must only contain lower case alphabetical characters and - but \"" + key + "\" was passed");
    }
  }

  var inserted = {}; // $FlowFixMe

  var container;

  if (isBrowser) {
    container = options.container || document.head;
    var nodes = document.querySelectorAll("style[data-emotion-" + key + "]");
    Array.prototype.forEach.call(nodes, function (node) {
      var attrib = node.getAttribute("data-emotion-" + key); // $FlowFixMe

      attrib.split(' ').forEach(function (id) {
        inserted[id] = true;
      });

      if (node.parentNode !== container) {
        container.appendChild(node);
      }
    });
  }

  var _insert;

  if (isBrowser) {
    stylis.use(options.stylisPlugins)(ruleSheet);

    _insert = function insert(selector, serialized, sheet, shouldCache) {
      var name = serialized.name;
      Sheet.current = sheet;

      if (process.env.NODE_ENV !== 'production' && serialized.map !== undefined) {
        var map = serialized.map;
        Sheet.current = {
          insert: function insert(rule) {
            sheet.insert(rule + map);
          }
        };
      }

      stylis(selector, serialized.styles);

      if (shouldCache) {
        cache.inserted[name] = true;
      }
    };
  } else {
    stylis.use(removeLabel);
    var serverStylisCache = rootServerStylisCache;

    if (options.stylisPlugins || options.prefix !== undefined) {
      stylis.use(options.stylisPlugins); // $FlowFixMe

      serverStylisCache = getServerStylisCache(options.stylisPlugins || rootServerStylisCache)(options.prefix);
    }

    var getRules = function getRules(selector, serialized) {
      var name = serialized.name;

      if (serverStylisCache[name] === undefined) {
        serverStylisCache[name] = stylis(selector, serialized.styles);
      }

      return serverStylisCache[name];
    };

    _insert = function _insert(selector, serialized, sheet, shouldCache) {
      var name = serialized.name;
      var rules = getRules(selector, serialized);

      {
        // in regular mode, we don't set the styles on the inserted cache
        // since we don't need to and that would be wasting memory
        // we return them so that they are rendered in a style tag
        if (shouldCache) {
          cache.inserted[name] = true;
        }

        if ( // using === development instead of !== production
        // because if people do ssr in tests, the source maps showing up would be annoying
        process.env.NODE_ENV === 'development' && serialized.map !== undefined) {
          return rules + serialized.map;
        }

        return rules;
      }
    };
  }

  if (process.env.NODE_ENV !== 'production') {
    // https://esbench.com/bench/5bf7371a4cd7e6009ef61d0a
    var commentStart = /\/\*/g;
    var commentEnd = /\*\//g;
    stylis.use(function (context, content) {
      switch (context) {
        case -1:
          {
            while (commentStart.test(content)) {
              commentEnd.lastIndex = commentStart.lastIndex;

              if (commentEnd.test(content)) {
                commentStart.lastIndex = commentEnd.lastIndex;
                continue;
              }

              throw new Error('Your styles have an unterminated comment ("/*" without corresponding "*/").');
            }

            commentStart.lastIndex = 0;
            break;
          }
      }
    });
    stylis.use(function (context, content, selectors) {
      switch (context) {
        case -1:
          {
            var flag = 'emotion-disable-server-rendering-unsafe-selector-warning-please-do-not-use-this-the-warning-exists-for-a-reason';
            var unsafePseudoClasses = content.match(/(:first|:nth|:nth-last)-child/g);

            if (unsafePseudoClasses && cache.compat !== true) {
              unsafePseudoClasses.forEach(function (unsafePseudoClass) {
                var ignoreRegExp = new RegExp(unsafePseudoClass + ".*\\/\\* " + flag + " \\*\\/");
                var ignore = ignoreRegExp.test(content);

                if (unsafePseudoClass && !ignore) {
                  console.error("The pseudo class \"" + unsafePseudoClass + "\" is potentially unsafe when doing server-side rendering. Try changing it to \"" + unsafePseudoClass.split('-child')[0] + "-of-type\".");
                }
              });
            }

            break;
          }
      }
    });
  }

  var cache = {
    key: key,
    sheet: new StyleSheet({
      key: key,
      container: container,
      nonce: options.nonce,
      speedy: options.speedy
    }),
    nonce: options.nonce,
    inserted: inserted,
    registered: {},
    insert: _insert
  };
  return cache;
};

var isBrowser$1 = typeof document !== 'undefined';
function getRegisteredStyles(registered, registeredStyles, classNames) {
  var rawClassName = '';
  classNames.split(' ').forEach(function (className) {
    if (registered[className] !== undefined) {
      registeredStyles.push(registered[className]);
    } else {
      rawClassName += className + " ";
    }
  });
  return rawClassName;
}
var insertStyles = function insertStyles(cache, serialized, isStringTag) {
  var className = cache.key + "-" + serialized.name;

  if ( // we only need to add the styles to the registered cache if the
  // class name could be used further down
  // the tree but if it's a string tag, we know it won't
  // so we don't have to add it to registered cache.
  // this improves memory usage since we can avoid storing the whole style string
  (isStringTag === false || // we need to always store it if we're in compat mode and
  // in node since emotion-server relies on whether a style is in
  // the registered cache to know whether a style is global or not
  // also, note that this check will be dead code eliminated in the browser
  isBrowser$1 === false && cache.compat !== undefined) && cache.registered[className] === undefined) {
    cache.registered[className] = serialized.styles;
  }

  if (cache.inserted[serialized.name] === undefined) {
    var stylesForSSR = '';
    var current = serialized;

    do {
      var maybeStyles = cache.insert("." + className, current, cache.sheet, true);

      if (!isBrowser$1 && maybeStyles !== undefined) {
        stylesForSSR += maybeStyles;
      }

      current = current.next;
    } while (current !== undefined);

    if (!isBrowser$1 && stylesForSSR.length !== 0) {
      return stylesForSSR;
    }
  }
};

/* eslint-disable */
// murmurhash2 via https://github.com/garycourt/murmurhash-js/blob/master/murmurhash2_gc.js
function murmurhash2_32_gc(str) {
  var l = str.length,
      h = l ^ l,
      i = 0,
      k;

  while (l >= 4) {
    k = str.charCodeAt(i) & 0xff | (str.charCodeAt(++i) & 0xff) << 8 | (str.charCodeAt(++i) & 0xff) << 16 | (str.charCodeAt(++i) & 0xff) << 24;
    k = (k & 0xffff) * 0x5bd1e995 + (((k >>> 16) * 0x5bd1e995 & 0xffff) << 16);
    k ^= k >>> 24;
    k = (k & 0xffff) * 0x5bd1e995 + (((k >>> 16) * 0x5bd1e995 & 0xffff) << 16);
    h = (h & 0xffff) * 0x5bd1e995 + (((h >>> 16) * 0x5bd1e995 & 0xffff) << 16) ^ k;
    l -= 4;
    ++i;
  }

  switch (l) {
    case 3:
      h ^= (str.charCodeAt(i + 2) & 0xff) << 16;

    case 2:
      h ^= (str.charCodeAt(i + 1) & 0xff) << 8;

    case 1:
      h ^= str.charCodeAt(i) & 0xff;
      h = (h & 0xffff) * 0x5bd1e995 + (((h >>> 16) * 0x5bd1e995 & 0xffff) << 16);
  }

  h ^= h >>> 13;
  h = (h & 0xffff) * 0x5bd1e995 + (((h >>> 16) * 0x5bd1e995 & 0xffff) << 16);
  h ^= h >>> 15;
  return (h >>> 0).toString(36);
}

var unitlessKeys = {
  animationIterationCount: 1,
  borderImageOutset: 1,
  borderImageSlice: 1,
  borderImageWidth: 1,
  boxFlex: 1,
  boxFlexGroup: 1,
  boxOrdinalGroup: 1,
  columnCount: 1,
  columns: 1,
  flex: 1,
  flexGrow: 1,
  flexPositive: 1,
  flexShrink: 1,
  flexNegative: 1,
  flexOrder: 1,
  gridRow: 1,
  gridRowEnd: 1,
  gridRowSpan: 1,
  gridRowStart: 1,
  gridColumn: 1,
  gridColumnEnd: 1,
  gridColumnSpan: 1,
  gridColumnStart: 1,
  msGridRow: 1,
  msGridRowSpan: 1,
  msGridColumn: 1,
  msGridColumnSpan: 1,
  fontWeight: 1,
  lineHeight: 1,
  opacity: 1,
  order: 1,
  orphans: 1,
  tabSize: 1,
  widows: 1,
  zIndex: 1,
  zoom: 1,
  WebkitLineClamp: 1,
  // SVG-related properties
  fillOpacity: 1,
  floodOpacity: 1,
  stopOpacity: 1,
  strokeDasharray: 1,
  strokeDashoffset: 1,
  strokeMiterlimit: 1,
  strokeOpacity: 1,
  strokeWidth: 1
};

var ILLEGAL_ESCAPE_SEQUENCE_ERROR = "You have illegal escape sequence in your template literal, most likely inside content's property value.\nBecause you write your CSS inside a JavaScript string you actually have to do double escaping, so for example \"content: '\\00d7';\" should become \"content: '\\\\00d7';\".\nYou can read more about this here:\nhttps://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Template_literals#ES2018_revision_of_illegal_escape_sequences";
var hyphenateRegex = /[A-Z]|^ms/g;
var animationRegex = /_EMO_([^_]+?)_([^]*?)_EMO_/g;

var isCustomProperty = function isCustomProperty(property) {
  return property.charCodeAt(1) === 45;
};

var processStyleName = memoize(function (styleName) {
  return isCustomProperty(styleName) ? styleName : styleName.replace(hyphenateRegex, '-$&').toLowerCase();
});

var processStyleValue = function processStyleValue(key, value) {
  if (value == null || typeof value === 'boolean') {
    return '';
  }

  switch (key) {
    case 'animation':
    case 'animationName':
      {
        if (typeof value === 'string') {
          return value.replace(animationRegex, function (match, p1, p2) {
            cursor = {
              name: p1,
              styles: p2,
              next: cursor
            };
            return p1;
          });
        }
      }
  }

  if (unitlessKeys[key] !== 1 && !isCustomProperty(key) && typeof value === 'number' && value !== 0) {
    return value + 'px';
  }

  return value;
};

if (process.env.NODE_ENV !== 'production') {
  var contentValuePattern = /(attr|calc|counters?|url)\(/;
  var contentValues = ['normal', 'none', 'counter', 'open-quote', 'close-quote', 'no-open-quote', 'no-close-quote', 'initial', 'inherit', 'unset'];
  var oldProcessStyleValue = processStyleValue;
  var msPattern = /^-ms-/;
  var hyphenPattern = /-(.)/g;
  var hyphenatedCache = {};

  processStyleValue = function processStyleValue(key, value) {
    if (key === 'content') {
      if (typeof value !== 'string' || contentValues.indexOf(value) === -1 && !contentValuePattern.test(value) && (value.charAt(0) !== value.charAt(value.length - 1) || value.charAt(0) !== '"' && value.charAt(0) !== "'")) {
        console.error("You seem to be using a value for 'content' without quotes, try replacing it with `content: '\"" + value + "\"'`");
      }
    }

    var processed = oldProcessStyleValue(key, value);

    if (processed !== '' && !isCustomProperty(key) && key.indexOf('-') !== -1 && hyphenatedCache[key] === undefined) {
      hyphenatedCache[key] = true;
      console.error("Using kebab-case for css properties in objects is not supported. Did you mean " + key.replace(msPattern, 'ms-').replace(hyphenPattern, function (str, _char) {
        return _char.toUpperCase();
      }) + "?");
    }

    return processed;
  };
}

var shouldWarnAboutInterpolatingClassNameFromCss = true;

function handleInterpolation(mergedProps, registered, interpolation, couldBeSelectorInterpolation) {
  if (interpolation == null) {
    return '';
  }

  if (interpolation.__emotion_styles !== undefined) {
    if (process.env.NODE_ENV !== 'production' && interpolation.toString() === 'NO_COMPONENT_SELECTOR') {
      throw new Error('Component selectors can only be used in conjunction with babel-plugin-emotion.');
    }

    return interpolation;
  }

  switch (typeof interpolation) {
    case 'boolean':
      {
        return '';
      }

    case 'object':
      {
        if (interpolation.anim === 1) {
          cursor = {
            name: interpolation.name,
            styles: interpolation.styles,
            next: cursor
          };
          return interpolation.name;
        }

        if (interpolation.styles !== undefined) {
          var next = interpolation.next;

          if (next !== undefined) {
            // not the most efficient thing ever but this is a pretty rare case
            // and there will be very few iterations of this generally
            while (next !== undefined) {
              cursor = {
                name: next.name,
                styles: next.styles,
                next: cursor
              };
              next = next.next;
            }
          }

          var styles = interpolation.styles;

          if (process.env.NODE_ENV !== 'production' && interpolation.map !== undefined) {
            styles += interpolation.map;
          }

          return styles;
        }

        return createStringFromObject(mergedProps, registered, interpolation);
      }

    case 'function':
      {
        if (mergedProps !== undefined) {
          var previousCursor = cursor;
          var result = interpolation(mergedProps);
          cursor = previousCursor;
          return handleInterpolation(mergedProps, registered, result, couldBeSelectorInterpolation);
        } else if (process.env.NODE_ENV !== 'production') {
          console.error('Functions that are interpolated in css calls will be stringified.\n' + 'If you want to have a css call based on props, create a function that returns a css call like this\n' + 'let dynamicStyle = (props) => css`color: ${props.color}`\n' + 'It can be called directly with props or interpolated in a styled call like this\n' + "let SomeComponent = styled('div')`${dynamicStyle}`");
        }
      }
    // eslint-disable-next-line no-fallthrough

    default:
      {
        if (registered == null) {
          return interpolation;
        }

        var cached = registered[interpolation];

        if (process.env.NODE_ENV !== 'production' && couldBeSelectorInterpolation && shouldWarnAboutInterpolatingClassNameFromCss && cached !== undefined) {
          console.error('Interpolating a className from css`` is not recommended and will cause problems with composition.\n' + 'Interpolating a className from css`` will be completely unsupported in a future major version of Emotion');
          shouldWarnAboutInterpolatingClassNameFromCss = false;
        }

        return cached !== undefined && !couldBeSelectorInterpolation ? cached : interpolation;
      }
  }
}

function createStringFromObject(mergedProps, registered, obj) {
  var string = '';

  if (Array.isArray(obj)) {
    for (var i = 0; i < obj.length; i++) {
      string += handleInterpolation(mergedProps, registered, obj[i], false);
    }
  } else {
    for (var _key in obj) {
      var value = obj[_key];

      if (typeof value !== 'object') {
        if (registered != null && registered[value] !== undefined) {
          string += _key + "{" + registered[value] + "}";
        } else {
          string += processStyleName(_key) + ":" + processStyleValue(_key, value) + ";";
        }
      } else {
        if (_key === 'NO_COMPONENT_SELECTOR' && process.env.NODE_ENV !== 'production') {
          throw new Error('Component selectors can only be used in conjunction with babel-plugin-emotion.');
        }

        if (Array.isArray(value) && typeof value[0] === 'string' && (registered == null || registered[value[0]] === undefined)) {
          for (var _i = 0; _i < value.length; _i++) {
            string += processStyleName(_key) + ":" + processStyleValue(_key, value[_i]) + ";";
          }
        } else {
          var interpolated = handleInterpolation(mergedProps, registered, value, false);

          switch (_key) {
            case 'animation':
            case 'animationName':
              {
                string += processStyleName(_key) + ":" + interpolated + ";";
                break;
              }

            default:
              {
                string += _key + "{" + interpolated + "}";
              }
          }
        }
      }
    }
  }

  return string;
}

var labelPattern = /label:\s*([^\s;\n{]+)\s*;/g;
var sourceMapPattern;

if (process.env.NODE_ENV !== 'production') {
  sourceMapPattern = /\/\*#\ssourceMappingURL=data:application\/json;\S+\s+\*\//;
} // this is the cursor for keyframes
// keyframes are stored on the SerializedStyles object as a linked list


var cursor;
var serializeStyles = function serializeStyles(args, registered, mergedProps) {
  if (args.length === 1 && typeof args[0] === 'object' && args[0] !== null && args[0].styles !== undefined) {
    return args[0];
  }

  var stringMode = true;
  var styles = '';
  cursor = undefined;
  var strings = args[0];

  if (strings == null || strings.raw === undefined) {
    stringMode = false;
    styles += handleInterpolation(mergedProps, registered, strings, false);
  } else {
    if (process.env.NODE_ENV !== 'production' && strings[0] === undefined) {
      console.error(ILLEGAL_ESCAPE_SEQUENCE_ERROR);
    }

    styles += strings[0];
  } // we start at 1 since we've already handled the first arg


  for (var i = 1; i < args.length; i++) {
    styles += handleInterpolation(mergedProps, registered, args[i], styles.charCodeAt(styles.length - 1) === 46);

    if (stringMode) {
      if (process.env.NODE_ENV !== 'production' && strings[i] === undefined) {
        console.error(ILLEGAL_ESCAPE_SEQUENCE_ERROR);
      }

      styles += strings[i];
    }
  }

  var sourceMap;

  if (process.env.NODE_ENV !== 'production') {
    styles = styles.replace(sourceMapPattern, function (match) {
      sourceMap = match;
      return '';
    });
  } // using a global regex with .exec is stateful so lastIndex has to be reset each time


  labelPattern.lastIndex = 0;
  var identifierName = '';
  var match; // https://esbench.com/bench/5b809c2cf2949800a0f61fb5

  while ((match = labelPattern.exec(styles)) !== null) {
    identifierName += '-' + // $FlowFixMe we know it's not null
    match[1];
  }

  var name = murmurhash2_32_gc(styles) + identifierName;

  if (process.env.NODE_ENV !== 'production') {
    return {
      name: name,
      styles: styles,
      map: sourceMap,
      next: cursor
    };
  }

  return {
    name: name,
    styles: styles,
    next: cursor
  };
};

var isBrowser$2 = typeof document !== 'undefined';

var EmotionCacheContext = createContext( // we're doing this to avoid preconstruct's dead code elimination in this one case
// because this module is primarily intended for the browser and node
// but it's also required in react native and similar environments sometimes
// and we could have a special build just for that
// but this is much easier and the native packages
// might use a different theme context in the future anyway
typeof HTMLElement !== 'undefined' ? createCache() : null);
var ThemeContext = createContext({});
var CacheProvider = EmotionCacheContext.Provider;

var withEmotionCache = function withEmotionCache(func) {
  var render = function render(props, ref) {
    return createElement(EmotionCacheContext.Consumer, null, function (cache) {
      return func(props, cache, ref);
    });
  }; // $FlowFixMe


  return forwardRef(render);
};

if (!isBrowser$2) {
  var BasicProvider =
  /*#__PURE__*/
  function (_React$Component) {
    inheritsLoose(BasicProvider, _React$Component);

    function BasicProvider(props, context, updater) {
      var _this;

      _this = _React$Component.call(this, props, context, updater) || this;
      _this.state = {
        value: createCache()
      };
      return _this;
    }

    var _proto = BasicProvider.prototype;

    _proto.render = function render() {
      return createElement(EmotionCacheContext.Provider, this.state, this.props.children(this.state.value));
    };

    return BasicProvider;
  }(Component);

  withEmotionCache = function withEmotionCache(func) {
    return function (props) {
      return createElement(EmotionCacheContext.Consumer, null, function (context) {
        if (context === null) {
          return createElement(BasicProvider, null, function (newContext) {
            return func(props, newContext);
          });
        } else {
          return func(props, context);
        }
      });
    };
  };
}

var typePropName = '__EMOTION_TYPE_PLEASE_DO_NOT_USE__';
var labelPropName = '__EMOTION_LABEL_PLEASE_DO_NOT_USE__';
var hasOwnProperty = Object.prototype.hasOwnProperty;

var render = function render(cache, props, theme, ref) {
  var cssProp = theme === null ? props.css : props.css(theme); // so that using `css` from `emotion` and passing the result to the css prop works
  // not passing the registered cache to serializeStyles because it would
  // make certain babel optimisations not possible

  if (typeof cssProp === 'string' && cache.registered[cssProp] !== undefined) {
    cssProp = cache.registered[cssProp];
  }

  var type = props[typePropName];
  var registeredStyles = [cssProp];
  var className = '';

  if (props.className !== undefined) {
    className = getRegisteredStyles(cache.registered, registeredStyles, props.className);
  }

  var serialized = serializeStyles(registeredStyles);

  if (process.env.NODE_ENV !== 'production' && serialized.name.indexOf('-') === -1) {
    var labelFromStack = props[labelPropName];

    if (labelFromStack) {
      serialized = serializeStyles([serialized, 'label:' + labelFromStack + ';']);
    }
  }

  var rules = insertStyles(cache, serialized, typeof type === 'string');
  className += cache.key + "-" + serialized.name;
  var newProps = {};

  for (var key in props) {
    if (hasOwnProperty.call(props, key) && key !== 'css' && key !== typePropName && (process.env.NODE_ENV === 'production' || key !== labelPropName)) {
      newProps[key] = props[key];
    }
  }

  newProps.ref = ref;
  newProps.className = className;
  var ele = createElement(type, newProps);

  if (!isBrowser$2 && rules !== undefined) {
    var _ref;

    var serializedNames = serialized.name;
    var next = serialized.next;

    while (next !== undefined) {
      serializedNames += ' ' + next.name;
      next = next.next;
    }

    return createElement(Fragment, null, createElement("style", (_ref = {}, _ref["data-emotion-" + cache.key] = serializedNames, _ref.dangerouslySetInnerHTML = {
      __html: rules
    }, _ref.nonce = cache.sheet.nonce, _ref)), ele);
  }

  return ele;
};

var Emotion =
/* #__PURE__ */
withEmotionCache(function (props, cache, ref) {
  // use Context.read for the theme when it's stable
  if (typeof props.css === 'function') {
    return createElement(ThemeContext.Consumer, null, function (theme) {
      return render(cache, props, theme, ref);
    });
  }

  return render(cache, props, null, ref);
});

if (process.env.NODE_ENV !== 'production') {
  Emotion.displayName = 'EmotionCssPropInternal';
} // $FlowFixMe

var warnedAboutCssPropForGlobal = false;
var Global =
/* #__PURE__ */
withEmotionCache(function (props, cache) {
  if (process.env.NODE_ENV !== 'production' && !warnedAboutCssPropForGlobal && ( // check for className as well since the user is
  // probably using the custom createElement which
  // means it will be turned into a className prop
  // $FlowFixMe I don't really want to add it to the type since it shouldn't be used
  props.className || props.css)) {
    console.error("It looks like you're using the css prop on Global, did you mean to use the styles prop instead?");
    warnedAboutCssPropForGlobal = true;
  }

  var styles = props.styles;

  if (typeof styles === 'function') {
    return createElement(ThemeContext.Consumer, null, function (theme) {
      var serialized = serializeStyles([styles(theme)]);
      return createElement(InnerGlobal, {
        serialized: serialized,
        cache: cache
      });
    });
  }

  var serialized = serializeStyles([styles]);
  return createElement(InnerGlobal, {
    serialized: serialized,
    cache: cache
  });
});

// maintain place over rerenders.
// initial render from browser, insertBefore context.sheet.tags[0] or if a style hasn't been inserted there yet, appendChild
// initial client-side render from SSR, use place of hydrating tag
var InnerGlobal =
/*#__PURE__*/
function (_React$Component) {
  inheritsLoose(InnerGlobal, _React$Component);

  function InnerGlobal(props, context, updater) {
    return _React$Component.call(this, props, context, updater) || this;
  }

  var _proto = InnerGlobal.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.sheet = new StyleSheet({
      key: this.props.cache.key + "-global",
      nonce: this.props.cache.sheet.nonce,
      container: this.props.cache.sheet.container
    }); // $FlowFixMe

    var node = document.querySelector("style[data-emotion-" + this.props.cache.key + "=\"" + this.props.serialized.name + "\"]");

    if (node !== null) {
      this.sheet.tags.push(node);
    }

    if (this.props.cache.sheet.tags.length) {
      this.sheet.before = this.props.cache.sheet.tags[0];
    }

    this.insertStyles();
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    if (prevProps.serialized.name !== this.props.serialized.name) {
      this.insertStyles();
    }
  };

  _proto.insertStyles = function insertStyles$1() {
    if (this.props.serialized.next !== undefined) {
      // insert keyframes
      insertStyles(this.props.cache, this.props.serialized.next, true);
    }

    if (this.sheet.tags.length) {
      // if this doesn't exist then it will be null so the style element will be appended
      var element = this.sheet.tags[this.sheet.tags.length - 1].nextElementSibling;
      this.sheet.before = element;
      this.sheet.flush();
    }

    this.props.cache.insert("", this.props.serialized, this.sheet, false);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.sheet.flush();
  };

  _proto.render = function render() {
    if (!isBrowser$2) {
      var serialized = this.props.serialized;
      var serializedNames = serialized.name;
      var serializedStyles = serialized.styles;
      var next = serialized.next;

      while (next !== undefined) {
        serializedNames += ' ' + next.name;
        serializedStyles += next.styles;
        next = next.next;
      }

      var shouldCache = this.props.cache.compat === true;
      var rules = this.props.cache.insert("", {
        name: serializedNames,
        styles: serializedStyles
      }, this.sheet, shouldCache);

      if (!shouldCache) {
        var _ref;

        return createElement("style", (_ref = {}, _ref["data-emotion-" + this.props.cache.key] = serializedNames, _ref.dangerouslySetInnerHTML = {
          __html: rules
        }, _ref.nonce = this.props.cache.sheet.nonce, _ref));
      }
    }

    return null;
  };

  return InnerGlobal;
}(Component);

var classnames = function classnames(args) {
  var len = args.length;
  var i = 0;
  var cls = '';

  for (; i < len; i++) {
    var arg = args[i];
    if (arg == null) continue;
    var toAdd = void 0;

    switch (typeof arg) {
      case 'boolean':
        break;

      case 'object':
        {
          if (Array.isArray(arg)) {
            toAdd = classnames(arg);
          } else {
            toAdd = '';

            for (var k in arg) {
              if (arg[k] && k) {
                toAdd && (toAdd += ' ');
                toAdd += k;
              }
            }
          }

          break;
        }

      default:
        {
          toAdd = arg;
        }
    }

    if (toAdd) {
      cls && (cls += ' ');
      cls += toAdd;
    }
  }

  return cls;
};

function merge(registered, css$$1, className) {
  var registeredStyles = [];
  var rawClassName = getRegisteredStyles(registered, registeredStyles, className);

  if (registeredStyles.length < 2) {
    return className;
  }

  return rawClassName + css$$1(registeredStyles);
}

var ClassNames = withEmotionCache(function (props, context) {
  return createElement(ThemeContext.Consumer, null, function (theme) {
    var rules = '';
    var serializedHashes = '';
    var hasRendered = false;

    var css$$1 = function css$$1() {
      if (hasRendered && process.env.NODE_ENV !== 'production') {
        throw new Error('css can only be used during render');
      }

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var serialized = serializeStyles(args, context.registered);

      if (isBrowser$2) {
        insertStyles(context, serialized, false);
      } else {
        var res = insertStyles(context, serialized, false);

        if (res !== undefined) {
          rules += res;
        }
      }

      if (!isBrowser$2) {
        serializedHashes += " " + serialized.name;
      }

      return context.key + "-" + serialized.name;
    };

    var cx = function cx() {
      if (hasRendered && process.env.NODE_ENV !== 'production') {
        throw new Error('cx can only be used during render');
      }

      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return merge(context.registered, css$$1, classnames(args));
    };

    var content = {
      css: css$$1,
      cx: cx,
      theme: theme
    };
    var ele = props.children(content);
    hasRendered = true;

    if (!isBrowser$2 && rules.length !== 0) {
      var _ref;

      return createElement(Fragment, null, createElement("style", (_ref = {}, _ref["data-emotion-" + context.key] = serializedHashes.substring(1), _ref.dangerouslySetInnerHTML = {
        __html: rules
      }, _ref.nonce = context.sheet.nonce, _ref)), ele);
    }

    return ele;
  });
});

var testOmitPropsOnStringTag = index;

var testOmitPropsOnComponent = function testOmitPropsOnComponent(key) {
  return key !== 'theme' && key !== 'innerRef';
};

var getDefaultShouldForwardProp = function getDefaultShouldForwardProp(tag) {
  return typeof tag === 'string' && // 96 is one less than the char code
  // for "a" so this is checking that
  // it's a lowercase character
  tag.charCodeAt(0) > 96 ? testOmitPropsOnStringTag : testOmitPropsOnComponent;
};

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var ILLEGAL_ESCAPE_SEQUENCE_ERROR$1 = "You have illegal escape sequence in your template literal, most likely inside content's property value.\nBecause you write your CSS inside a JavaScript string you actually have to do double escaping, so for example \"content: '\\00d7';\" should become \"content: '\\\\00d7';\".\nYou can read more about this here:\nhttps://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Template_literals#ES2018_revision_of_illegal_escape_sequences";
var isBrowser$3 = typeof document !== 'undefined';

var createStyled = function createStyled(tag, options) {
  if (process.env.NODE_ENV !== 'production') {
    if (tag === undefined) {
      throw new Error('You are trying to create a styled element with an undefined component.\nYou may have forgotten to import it.');
    }
  }

  var identifierName;
  var shouldForwardProp;
  var targetClassName;

  if (options !== undefined) {
    identifierName = options.label;
    targetClassName = options.target;
    shouldForwardProp = tag.__emotion_forwardProp && options.shouldForwardProp ? function (propName) {
      return tag.__emotion_forwardProp(propName) && // $FlowFixMe
      options.shouldForwardProp(propName);
    } : options.shouldForwardProp;
  }

  var isReal = tag.__emotion_real === tag;
  var baseTag = isReal && tag.__emotion_base || tag;

  if (typeof shouldForwardProp !== 'function' && isReal) {
    shouldForwardProp = tag.__emotion_forwardProp;
  }

  var defaultShouldForwardProp = shouldForwardProp || getDefaultShouldForwardProp(baseTag);
  var shouldUseAs = !defaultShouldForwardProp('as');
  return function () {
    var args = arguments;
    var styles = isReal && tag.__emotion_styles !== undefined ? tag.__emotion_styles.slice(0) : [];

    if (identifierName !== undefined) {
      styles.push("label:" + identifierName + ";");
    }

    if (args[0] == null || args[0].raw === undefined) {
      styles.push.apply(styles, args);
    } else {
      if (process.env.NODE_ENV !== 'production' && args[0][0] === undefined) {
        console.error(ILLEGAL_ESCAPE_SEQUENCE_ERROR$1);
      }

      styles.push(args[0][0]);
      var len = args.length;
      var i = 1;

      for (; i < len; i++) {
        if (process.env.NODE_ENV !== 'production' && args[0][i] === undefined) {
          console.error(ILLEGAL_ESCAPE_SEQUENCE_ERROR$1);
        }

        styles.push(args[i], args[0][i]);
      }
    }

    var Styled = withEmotionCache(function (props, context, ref) {
      return createElement(ThemeContext.Consumer, null, function (theme) {
        var finalTag = shouldUseAs && props.as || baseTag;
        var className = '';
        var classInterpolations = [];
        var mergedProps = props;

        if (props.theme == null) {
          mergedProps = {};

          for (var key in props) {
            mergedProps[key] = props[key];
          }

          mergedProps.theme = theme;
        }

        if (typeof props.className === 'string') {
          className += getRegisteredStyles(context.registered, classInterpolations, props.className);
        }

        var serialized = serializeStyles(styles.concat(classInterpolations), context.registered, mergedProps);
        var rules = insertStyles(context, serialized, typeof finalTag === 'string');
        className += context.key + "-" + serialized.name;

        if (targetClassName !== undefined) {
          className += " " + targetClassName;
        }

        var finalShouldForwardProp = shouldUseAs && shouldForwardProp === undefined ? getDefaultShouldForwardProp(finalTag) : defaultShouldForwardProp;
        var newProps = {};

        for (var _key in props) {
          if (shouldUseAs && _key === 'as') continue;

          if ( // $FlowFixMe
          finalShouldForwardProp(_key)) {
            newProps[_key] = props[_key];
          }
        }

        newProps.className = className;
        newProps.ref = ref || props.innerRef;

        if (process.env.NODE_ENV !== 'production' && props.innerRef) {
          console.error('`innerRef` is deprecated and will be removed in a future major version of Emotion, please use the `ref` prop instead' + (identifierName === undefined ? '' : " in the usage of `" + identifierName + "`"));
        }

        var ele = createElement(finalTag, newProps);

        if (!isBrowser$3 && rules !== undefined) {
          var _ref;

          var serializedNames = serialized.name;
          var next = serialized.next;

          while (next !== undefined) {
            serializedNames += ' ' + next.name;
            next = next.next;
          }

          return createElement(Fragment, null, createElement("style", (_ref = {}, _ref["data-emotion-" + context.key] = serializedNames, _ref.dangerouslySetInnerHTML = {
            __html: rules
          }, _ref.nonce = context.sheet.nonce, _ref)), ele);
        }

        return ele;
      });
    });
    Styled.displayName = identifierName !== undefined ? identifierName : "Styled(" + (typeof baseTag === 'string' ? baseTag : baseTag.displayName || baseTag.name || 'Component') + ")";
    Styled.defaultProps = tag.defaultProps;
    Styled.__emotion_real = Styled;
    Styled.__emotion_base = baseTag;
    Styled.__emotion_styles = styles;
    Styled.__emotion_forwardProp = shouldForwardProp;
    Object.defineProperty(Styled, 'toString', {
      value: function value() {
        if (targetClassName === undefined && process.env.NODE_ENV !== 'production') {
          return 'NO_COMPONENT_SELECTOR';
        } // $FlowFixMe


        return "." + targetClassName;
      }
    });

    Styled.withComponent = function (nextTag, nextOptions) {
      return createStyled(nextTag, nextOptions !== undefined ? _objectSpread({}, options || {}, {}, nextOptions) : options).apply(void 0, styles);
    };

    return Styled;
  };
};

var tags = ['a', 'abbr', 'address', 'area', 'article', 'aside', 'audio', 'b', 'base', 'bdi', 'bdo', 'big', 'blockquote', 'body', 'br', 'button', 'canvas', 'caption', 'cite', 'code', 'col', 'colgroup', 'data', 'datalist', 'dd', 'del', 'details', 'dfn', 'dialog', 'div', 'dl', 'dt', 'em', 'embed', 'fieldset', 'figcaption', 'figure', 'footer', 'form', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'head', 'header', 'hgroup', 'hr', 'html', 'i', 'iframe', 'img', 'input', 'ins', 'kbd', 'keygen', 'label', 'legend', 'li', 'link', 'main', 'map', 'mark', 'marquee', 'menu', 'menuitem', 'meta', 'meter', 'nav', 'noscript', 'object', 'ol', 'optgroup', 'option', 'output', 'p', 'param', 'picture', 'pre', 'progress', 'q', 'rp', 'rt', 'ruby', 's', 'samp', 'script', 'section', 'select', 'small', 'source', 'span', 'strong', 'style', 'sub', 'summary', 'sup', 'table', 'tbody', 'td', 'textarea', 'tfoot', 'th', 'thead', 'time', 'title', 'tr', 'track', 'u', 'ul', 'var', 'video', 'wbr', // SVG
'circle', 'clipPath', 'defs', 'ellipse', 'foreignObject', 'g', 'image', 'line', 'linearGradient', 'mask', 'path', 'pattern', 'polygon', 'polyline', 'radialGradient', 'rect', 'stop', 'svg', 'text', 'tspan'];

var newStyled = createStyled.bind();
tags.forEach(function (tagName) {
  newStyled[tagName] = newStyled(tagName);
});

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var taggedTemplateLiteral = function (strings, raw) {
  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
};

var _templateObject = taggedTemplateLiteral(['\n  .container {\n    width: 200px;\n    height: 100px;\n    padding-top: 100px;\n    margin: 0 auto;\n  }\n\n  .ball {\n    width: 90px;\n    height: 10px;\n    margin: 10px auto;\n    border-radius: 50px;\n  }\n  .ball:nth-of-type(1) {\n    background: #d33ca3;\n    -webkit-animation: right 1s infinite ease-in-out;\n    -moz-animation: right 1s infinite ease-in-out;\n    animation: right 1s infinite ease-in-out;\n  }\n\n  .ball:nth-of-type(2) {\n    background: #39d09a;\n    -webkit-animation: left 1.1s infinite ease-in-out;\n    -moz-animation: left 1.1s infinite ease-in-out;\n    animation: left 1.1s infinite ease-in-out;\n  }\n\n  .ball:nth-of-type(3) {\n    background: #2b6ae8;\n    -webkit-animation: right 1.05s infinite ease-in-out;\n    -moz-animation: right 1.05s infinite ease-in-out;\n    animation: right 1.05s infinite ease-in-out;\n  }\n\n  .ball:nth-of-type(4) {\n    background: #824df3;\n    -webkit-animation: left 1.15s infinite ease-in-out;\n    -moz-animation: left 1.15s infinite ease-in-out;\n    animation: left 1.15s infinite ease-in-out;\n  }\n\n  .ball:nth-of-type(5) {\n    background: #db2f59;\n    -webkit-animation: right 1.1s infinite ease-in-out;\n    -moz-animation: right 1.1s infinite ease-in-out;\n    animation: right 1.1s infinite ease-in-out;\n  }\n\n  .ball:nth-of-type(6) {\n    background: #fc7161;\n    -webkit-animation: left 1.05s infinite ease-in-out;\n    -moz-animation: left 1.05s infinite ease-in-out;\n    animation: left 1.05s infinite ease-in-out;\n  }\n\n  .ball:nth-of-type(7) {\n    background: #ffbc4b;\n    -webkit-animation: right 1s infinite ease-in-out;\n    -moz-animation: right 1s infinite ease-in-out;\n    animation: right 1s infinite ease-in-out;\n  }\n\n  @-webkit-keyframes right {\n    0% {\n      -webkit-transform: translate(-15px);\n    }\n    50% {\n      -webkit-transform: translate(15px);\n    }\n    100% {\n      -webkit-transform: translate(-15px);\n    }\n  }\n\n  @-webkit-keyframes left {\n    0% {\n      -webkit-transform: translate(15px);\n    }\n    50% {\n      -webkit-transform: translate(-15px);\n    }\n    100% {\n      -webkit-transform: translate(15px);\n    }\n  }\n\n  @-moz-keyframes right {\n    0% {\n      -moz-transform: translate(-15px);\n    }\n    50% {\n      -moz-transform: translate(15px);\n    }\n    100% {\n      -moz-transform: translate(-15px);\n    }\n  }\n\n  @-moz-keyframes left {\n    0% {\n      -moz-transform: translate(15px);\n    }\n    50% {\n      -moz-transform: translate(-15px);\n    }\n    100% {\n      -moz-transform: translate(15px);\n    }\n  }\n\n  @keyframes right {\n    0% {\n      transform: translate(-15px);\n    }\n    50% {\n      transform: translate(15px);\n    }\n    100% {\n      transform: translate(-15px);\n    }\n  }\n\n  @keyframes left {\n    0% {\n      transform: translate(15px);\n    }\n    50% {\n      transform: translate(-15px);\n    }\n    100% {\n      transform: translate(15px);\n    }\n  }\n'], ['\n  .container {\n    width: 200px;\n    height: 100px;\n    padding-top: 100px;\n    margin: 0 auto;\n  }\n\n  .ball {\n    width: 90px;\n    height: 10px;\n    margin: 10px auto;\n    border-radius: 50px;\n  }\n  .ball:nth-of-type(1) {\n    background: #d33ca3;\n    -webkit-animation: right 1s infinite ease-in-out;\n    -moz-animation: right 1s infinite ease-in-out;\n    animation: right 1s infinite ease-in-out;\n  }\n\n  .ball:nth-of-type(2) {\n    background: #39d09a;\n    -webkit-animation: left 1.1s infinite ease-in-out;\n    -moz-animation: left 1.1s infinite ease-in-out;\n    animation: left 1.1s infinite ease-in-out;\n  }\n\n  .ball:nth-of-type(3) {\n    background: #2b6ae8;\n    -webkit-animation: right 1.05s infinite ease-in-out;\n    -moz-animation: right 1.05s infinite ease-in-out;\n    animation: right 1.05s infinite ease-in-out;\n  }\n\n  .ball:nth-of-type(4) {\n    background: #824df3;\n    -webkit-animation: left 1.15s infinite ease-in-out;\n    -moz-animation: left 1.15s infinite ease-in-out;\n    animation: left 1.15s infinite ease-in-out;\n  }\n\n  .ball:nth-of-type(5) {\n    background: #db2f59;\n    -webkit-animation: right 1.1s infinite ease-in-out;\n    -moz-animation: right 1.1s infinite ease-in-out;\n    animation: right 1.1s infinite ease-in-out;\n  }\n\n  .ball:nth-of-type(6) {\n    background: #fc7161;\n    -webkit-animation: left 1.05s infinite ease-in-out;\n    -moz-animation: left 1.05s infinite ease-in-out;\n    animation: left 1.05s infinite ease-in-out;\n  }\n\n  .ball:nth-of-type(7) {\n    background: #ffbc4b;\n    -webkit-animation: right 1s infinite ease-in-out;\n    -moz-animation: right 1s infinite ease-in-out;\n    animation: right 1s infinite ease-in-out;\n  }\n\n  @-webkit-keyframes right {\n    0% {\n      -webkit-transform: translate(-15px);\n    }\n    50% {\n      -webkit-transform: translate(15px);\n    }\n    100% {\n      -webkit-transform: translate(-15px);\n    }\n  }\n\n  @-webkit-keyframes left {\n    0% {\n      -webkit-transform: translate(15px);\n    }\n    50% {\n      -webkit-transform: translate(-15px);\n    }\n    100% {\n      -webkit-transform: translate(15px);\n    }\n  }\n\n  @-moz-keyframes right {\n    0% {\n      -moz-transform: translate(-15px);\n    }\n    50% {\n      -moz-transform: translate(15px);\n    }\n    100% {\n      -moz-transform: translate(-15px);\n    }\n  }\n\n  @-moz-keyframes left {\n    0% {\n      -moz-transform: translate(15px);\n    }\n    50% {\n      -moz-transform: translate(-15px);\n    }\n    100% {\n      -moz-transform: translate(15px);\n    }\n  }\n\n  @keyframes right {\n    0% {\n      transform: translate(-15px);\n    }\n    50% {\n      transform: translate(15px);\n    }\n    100% {\n      transform: translate(-15px);\n    }\n  }\n\n  @keyframes left {\n    0% {\n      transform: translate(15px);\n    }\n    50% {\n      transform: translate(-15px);\n    }\n    100% {\n      transform: translate(15px);\n    }\n  }\n']);

// NOTE
/*
Loader found at: https://codepen.io/asmaharjan/pen/EuaIF
*/

var Container = newStyled.div(_templateObject);

var Loading = function Loading() {
  return React.createElement(
    Container,
    null,
    React.createElement(
      'div',
      { className: 'container' },
      React.createElement('div', { className: 'ball' }),
      React.createElement('div', { className: 'ball' }),
      React.createElement('div', { className: 'ball' }),
      React.createElement('div', { className: 'ball' }),
      React.createElement('div', { className: 'ball' }),
      React.createElement('div', { className: 'ball' }),
      React.createElement('div', { className: 'ball' })
    )
  );
};

var query = '{\n  illustrationTypeCollection {\n    total\n    items {\n      name\n      illustrationsCollection {\n        total\n        items {\n          ... on Illustration {\n            name\n            color1\n            color2\n            code\n            code2\n            code3\n            tags\n          }\n        }\n      }\n    }\n  }\n}';

// FIXME  Fixes
// 2. borderRadius = {} -> breaks, is it possible to put 0 when the value is null

// 13. Update ReadME
// 14. Fix props with no value -> right now it crashes
// 15. 404 for spelling errors

var Illustrations = function (_React$Component) {
  inherits(Illustrations, _React$Component);

  function Illustrations(props) {
    classCallCheck(this, Illustrations);

    var _this = possibleConstructorReturn(this, (Illustrations.__proto__ || Object.getPrototypeOf(Illustrations)).call(this, props));

    _this.state = {
      data: []
    };
    return _this;
  }

  createClass(Illustrations, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var _props = this.props,
          accessToken = _props.accessToken,
          spaceId = _props.spaceId;

      fetch('https://graphql.contentful.com/content/v1/spaces/' + spaceId + '/environments/master', {
        method: 'POST',
        headers: {
          'content-type': 'application/json',
          authorization: 'Bearer ' + accessToken
        },
        body: JSON.stringify({
          query: query
        })
      }).then(function (res) {
        return res.json();
      }).then(function (response) {
        var data = response.data;


        _this2.setState({
          data: data ? data.illustrationTypeCollection.items : []
        });
      }).catch(function (error) {
        // error page
        console.log(error);
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var data = this.state.data;
      var _props2 = this.props,
          category = _props2.category,
          name = _props2.name,
          primaryColor = _props2.primaryColor,
          size = _props2.size,
          secondaryColor = _props2.secondaryColor,
          backgroundColor = _props2.backgroundColor,
          theme = _props2.theme,
          borderRadius = _props2.borderRadius;


      var selected = '';

      data.map(function (item) {
        if (item.name.toLowerCase() === category.toLowerCase()) {
          item.illustrationsCollection.items.filter(function (illustration) {
            try {
              if (illustration.name !== null && name.toLowerCase() === illustration.name.toLowerCase()) {
                selected = illustration;
              }
            } catch (error) {}
          });
        }
      });

      var code = '' + selected.code + selected.code2 + selected.code3;

      var themeOne = {
        primaryColor: '#FF5E5E',
        secondaryColor: '#1B5C6A'
      };

      var themeTwo = {
        primaryColor: '#FCAACF',
        secondaryColor: '#2249B3'
      };

      var themeThree = {
        primaryColor: '#193170',
        secondaryColor: '#2357DD'
      };

      var themeFour = {
        primaryColor: '#F8B500',
        secondaryColor: '#5E227F'
      };
      var themeFive = {
        primaryColor: '#FFB6B6',
        secondaryColor: '#139DB8'
      };

      var themeSix = {
        primaryColor: '#FFD06F',
        secondaryColor: '#28323F'
      };

      var themeSeven = {
        primaryColor: '#07038C',
        secondaryColor: '#F20505'
      };

      var defaultThemes = {
        primaryColor: primaryColor,
        secondaryColor: secondaryColor
      };

      var defaultColors = {
        // primaryColor: '#303131',
        // secondaryColor: '#4A90E2'

        primaryColor: '#f7f5f6',
        secondaryColor: 'black'
      };

      var selectedTheme = '';

      if (theme === 1) {
        selectedTheme = themeOne;
      } else if (theme === 2) {
        selectedTheme = themeTwo;
      } else if (theme === 3) {
        selectedTheme = themeThree;
      } else if (theme === 4) {
        selectedTheme = themeFour;
      } else if (theme === 5) {
        selectedTheme = themeFive;
      } else if (theme === 6) {
        selectedTheme = themeSix;
      } else if (theme === 7) {
        selectedTheme = themeSeven;
      } else if (this.props.primaryColor || this.props.secondaryColor) {
        selectedTheme = defaultThemes;
      } else {
        selectedTheme = defaultColors;
      }

      function getSVGContents(inputString) {
        var domParser = new DOMParser();
        var svgDOM = domParser.parseFromString(inputString, 'text/xml');
        var nums = [];

        if (svgDOM !== undefined) {
          // NOTE Works on some
          // for (var i = 0; i <= svgDOM.getElementsByTagName('path').length - 1; i++) {
          //   if (svgDOM.getElementsByTagName('path')[i].getAttribute('fill') === '') {
          //     nums.push(i);
          //   } else {
          //     console.log(false);
          //   }
          // }

          for (var i = 0; i <= svgDOM.getElementsByTagName('*').length - 1; i++) {
            if (svgDOM.getElementsByTagName('*')[i].getAttribute('fill') === ' ' || svgDOM.getElementsByTagName('*')[i].getAttribute('fill') === '' || svgDOM.getElementsByTagName('*')[i].getAttribute('fill') === '  ') {
              nums.push(i);
            }
          }

          try {
            if (nums.length === 2) {
              svgDOM.getElementsByTagName('*')[nums[0]].setAttribute('fill', selectedTheme.primaryColor);

              svgDOM.getElementsByTagName('*')[nums[1]].setAttribute('fill', selectedTheme.secondaryColor);
            } else if (nums.length === 1) {
              svgDOM.getElementsByTagName('*')[nums[0]].setAttribute('fill', selectedTheme.primaryColor);
            }

            return svgDOM.getElementsByTagName('svg')[0].innerHTML;
          } catch (error) {}

          // try {
          //   svgDOM
          //     .getElementsByTagName('path')
          //     [nums[0]].setAttribute('fill', selectedTheme.primaryColor);
          //   svgDOM
          //     .getElementsByTagName('path')
          //     [nums[1]].setAttribute('fill', selectedTheme.secondaryColor);

          //   return svgDOM.getElementsByTagName('svg')[0].innerHTML;
          // } catch (error) {}
        }
      }
      // ${getSVGContents(code) !== undefined ? getSVGContents(code) : ''}
      var svgString = '\n      <svg class="illustration" width=' + size + ' height=' + size + ' viewBox="0 0 1155 700" fill="none" xmlns="http://www.w3.org/2000/svg">\n        ' + getSVGContents(code) + '\n      </svg>';

      var styles = {
        backgroundColor: backgroundColor,
        borderRadius: borderRadius
      };

      return React.createElement(
        'div',
        null,
        getSVGContents(code) !== undefined ? React.createElement('div', { style: styles, dangerouslySetInnerHTML: { __html: svgString } }) : React.createElement(Loading, null)
      );
    }
  }]);
  return Illustrations;
}(React.Component);

Illustrations.propTypes = {
  category: PropTypes.string,
  name: PropTypes.string,
  primaryColor: PropTypes.string,
  secondaryColor: PropTypes.string,
  backgroundColor: PropTypes.string,
  borderRadius: PropTypes.number,
  theme: PropTypes.number
};


Illustrations.defaultProps = {
  borderRadius: 0,
  backgroundColor: 'none',
  size: 900
};

var query$1 = '\n{\n  typeCollection {\n    total\n    items {\n      type\n      iconsCollection {\n        total\n        items{\n            ... on Icon {\n              name\n              url\n              d1\n              d2\n              d3\n              color1\n              color2\n              color3\n              opacity\n              tags\n            }\n        }\n      }\n    }\n  }\n}\n';

var Icons = function (_React$Component) {
  inherits(Icons, _React$Component);

  function Icons(props) {
    classCallCheck(this, Icons);

    var _this = possibleConstructorReturn(this, (Icons.__proto__ || Object.getPrototypeOf(Icons)).call(this, props));

    _this.state = {
      data: []
    };
    return _this;
  }

  createClass(Icons, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      fetch('https://graphql.contentful.com/content/v1/spaces/' + this.props.spaceId + '/environments/master', {
        method: 'POST',
        headers: {
          'content-type': 'application/json',
          authorization: 'Bearer ' + this.props.accessToken
        },
        body: JSON.stringify({
          query: query$1
        })
      }).then(function (res) {
        return res.json();
      }).then(function (response) {
        var data = response.data;


        _this2.setState({
          data: data ? response.data.typeCollection.items : []
        });
      }).catch(function (error) {
        console.log(error);
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var data = this.state.data;
      var _props = this.props,
          category = _props.category,
          name = _props.name,
          primaryColor = _props.primaryColor,
          size = _props.size,
          secondaryColor = _props.secondaryColor,
          backgroundColor = _props.backgroundColor,
          borderRadius = _props.borderRadius,
          theme = _props.theme;


      var iconData = {};

      data.filter(function (icon) {
        if (icon.type.toLowerCase() === category.toLowerCase()) {
          // else - the category does not exist
          icon.iconsCollection.items.filter(function (item) {
            try {
              if (item.name.toLowerCase() === name.toLowerCase()) {
                // else - there is no icon by that name in that category
                iconData = item;
              }
            } catch (error) {}
          });
        }
      });

      var themeOne = {
        primaryColor: '#FF5E5E',
        secondaryColor: '#1B5C6A'
      };

      var themeTwo = {
        primaryColor: '#FCAACF',
        secondaryColor: '#2249B3'
      };

      var themeThree = {
        primaryColor: '#193170',
        secondaryColor: '#2357DD'
      };

      var themeFour = {
        primaryColor: '#F8B500',
        secondaryColor: '#5E227F'
      };
      var themeFive = {
        primaryColor: '#FFB6B6',
        secondaryColor: '#139DB8'
      };

      var themeSix = {
        primaryColor: '#FFD06F',
        secondaryColor: '#28323F'
      };

      var themeSeven = {
        primaryColor: '#07038C',
        secondaryColor: '#F20505'
      };

      var defaultThemes = {
        primaryColor: primaryColor,
        secondaryColor: secondaryColor
      };

      var defaultColors = {
        // primaryColor: '#303131',
        // secondaryColor: '#4A90E2'

        primaryColor: '#f7f5f6',
        secondaryColor: 'black'
      };

      var selectedTheme = '';

      if (theme === 1) {
        selectedTheme = themeOne;
      } else if (theme === 2) {
        selectedTheme = themeTwo;
      } else if (theme === 3) {
        selectedTheme = themeThree;
      } else if (theme === 4) {
        selectedTheme = themeFour;
      } else if (theme === 5) {
        selectedTheme = themeFive;
      } else if (theme === 6) {
        selectedTheme = themeSix;
      } else if (theme === 7) {
        selectedTheme = themeSeven;
      } else if (this.props.primaryColor || this.props.secondaryColor) {
        selectedTheme = defaultThemes;
      } else {
        selectedTheme = defaultColors;
      }

      return React.createElement(
        'div',
        null,
        iconData === {} ? React.createElement(
          'svg',
          {
            className: 'illustration',
            width: '1152',
            height: '700',
            viewBox: '0 0 1152 700',
            fill: 'none',
            xmlns: 'http://www.w3.org/2000/svg'
          },
          React.createElement('path', {
            fillRule: 'evenodd',
            clipRule: 'evenodd',
            d: 'M683.5 247.5L662.732 254.267L639 261.776V262V277.895V278L753.5 331L753.696 330.919L753.871 331L848.195 292.079L859.695 296.413L927.5 322L927.534 321.984L927.578 322L963.798 304.597L964 304.5V292.079V292L908.803 270.617L916 267.756V267.5V253L879.014 237.921L878.616 238.046L878.5 238L848 247.5L826.44 239.415L764.144 216L764.067 216.025L764 216L753.706 219.431L724.92 228.895V241L789.436 267.524L753.569 280.974L683.828 247.592L683.746 247.618L683.5 247.5ZM198.732 447.267L219.5 440.5L219.746 440.618L219.828 440.592L289.569 473.974L325.436 460.524L260.92 434V421.895L289.706 412.431L300 409L300.067 409.025L300.144 409L362.432 432.412L384 440.5L414.5 431L414.616 431.046L415.014 430.921L452 446V460.5V460.756L444.803 463.617L500 485V485.079V497.5L499.791 497.6L463.578 515L463.534 514.984L463.5 515L395.7 489.415L384.195 485.079L289.871 524L289.696 523.919L289.5 524L175 471V470.895V455V454.776L198.732 447.267ZM564.089 307L758 373.712V390L564.089 453.5L357 384V368.288L564.089 307Z',
            fill: ''
          }),
          React.createElement('path', {
            opacity: '0.2',
            d: 'M175 455L219.5 440.5L289.5 474L325.5 460.5L261 434V422L300 409L384 440.5L414.5 431L452 446V460.5L444.5 463.5L500 485V497.5L463.5 515L384 485L289.5 524L175 471V455Z',
            fill: '#DAE4FA'
          }),
          React.createElement('path', {
            opacity: '0.2',
            d: 'M219.828 440.592L175 454.776L289.871 507L384.195 470.895L463.578 500.553L500 485.079L428.089 457.355L452 446L415.014 430.921L384.195 440.592L300.144 409L260.92 421.895L342.17 454.776L289.871 474.118L219.828 440.592Z',
            fill: '#EE7E79'
          }),
          React.createElement('path', {
            opacity: '0.2',
            d: 'M639 262L683.5 247.5L753.5 281L789.5 267.5L725 241V229L764 216L848 247.5L878.5 238L916 253V267.5L908.5 270.5L964 292V304.5L927.5 322L848 292L753.5 331L639 278V262Z',
            fill: '#DAE4FA'
          }),
          React.createElement('path', {
            opacity: '0.2',
            d: 'M683.828 247.592L639 261.776L753.871 314L848.195 277.895L927.578 307.553L964 292.079L892.089 264.355L916 253L879.014 237.921L848.195 247.592L764.144 216L724.92 228.895L806.17 261.776L753.871 281.118L683.828 247.592Z',
            fill: '#EE7E79'
          }),
          React.createElement('path', {
            opacity: '0.2',
            d: 'M357 368.288L564.089 435L758 373.712V390L564.089 453.5L357 384V368.288Z',
            fill: '#DAE4FA'
          }),
          React.createElement('path', {
            d: 'M564.089 435L357 368.288L564.089 307L758 373.712L564.089 435Z',
            fill: 'url(#paint0_linear)'
          }),
          React.createElement('path', {
            fillRule: 'evenodd',
            clipRule: 'evenodd',
            d: 'M525.708 116.279L538.123 116.142L611 491.288L597.014 486.711L580.179 397.942L496.564 407.326L513.578 507L501.163 503.994L433 113.137L445.415 113L457.93 180.122L539.118 183.202L525.708 116.279ZM540.799 195.524L459.641 192.44L476.406 287.644L558.822 282.919L540.799 195.524ZM494.853 395.008L478.117 299.962L560.504 295.242L578.497 385.62L494.853 395.008Z',
            fill: '#DAE4FA'
          }),
          React.createElement('path', {
            d: 'M599.339 310.765C597.708 311.172 583.201 309.915 579.21 314.332C572.585 308.726 561.5 267 560 264.5L556.5 258.5C554.611 257.137 551 257.5 549.5 254.5C549.037 253.574 551.86 254.321 551 252.925C549.453 250.411 549.356 247.06 548.379 246.3C546.085 244.516 544.811 239.93 544.811 238.656C544.811 237.382 545.464 236.627 548.888 238.656C552 240.5 556.5 238.656 561 240.5C567.147 243.018 565.195 249.867 566.724 252.925C568.253 255.982 601.377 310.255 599.339 310.765Z',
            fill: '#EDC7C5'
          }),
          React.createElement('path', {
            d: 'M534.11 370.388C532.275 368.757 538.441 353.231 541.754 345.672C535.554 344.398 521.064 341.85 512.707 341.85C502.26 341.85 490.029 330.129 490.029 328.855C490.029 327.581 488.501 320.447 487.736 317.899C486.972 315.351 488.501 307.452 483.914 308.217C479.328 308.981 482.385 320.957 480.856 321.976C479.328 322.995 473.467 319.937 469.9 320.957C466.333 321.976 467.607 323.759 467.097 325.288C464.549 327.072 467.862 330.129 465.823 331.658C464.193 332.881 464.634 335.056 465.059 335.99C464.634 337.009 464.04 339.608 465.059 341.85C466.333 344.653 470.664 342.36 473.467 344.908C476.27 347.456 481.621 346.182 485.443 348.73C489.01 355.355 536.403 372.426 534.11 370.388Z',
            fill: '#EDC7C5'
          }),
          React.createElement('path', {
            fillRule: 'evenodd',
            clipRule: 'evenodd',
            d: 'M572.013 249.639C573.735 246.227 571.129 242.115 570.22 241.428L532.468 250.747C532.161 251.069 531.983 251.454 531.906 251.878L509.429 256.474C509.426 257.423 509.645 259.665 510.552 261.036L533.131 256.106L533.131 256.106C533.476 256.685 533.84 257.2 534.152 257.591L572.013 249.639ZM496.208 257.337C496.48 255.591 496.547 251.823 494.637 250.722L493.512 246.729L500.925 245.047L501.821 249.153C501.208 250.594 500.664 253.935 503.392 255.768L503.392 255.768L503.392 255.768C504.664 256.958 507.946 256.734 509.429 256.474C509.425 257.424 509.645 259.665 510.551 261.036C508.088 261.574 505.872 263.07 505.072 263.751L505.072 263.751C505.325 269.312 511.535 272.397 514.609 273.244L513.691 274.836C499.026 271.865 495.925 261.932 496.207 257.337L496.208 257.337ZM637.744 290.134C641.606 293.235 644.69 295.494 645.457 295.494C647.75 295.494 648.005 294.475 646.731 292.691C646.038 291.721 646.477 291.354 646.98 290.933C647.401 290.581 647.867 290.192 647.75 289.379C647.496 287.595 647.496 287.086 648.77 285.302C650.044 283.519 657.942 268.231 646.731 256.255C635.52 244.279 622.27 243.515 613.862 248.611C608.68 251.752 606.885 253.537 605.972 254.446C605.404 255.011 605.178 255.236 604.689 255.236C603.67 255.236 602.226 256.255 601.632 256.765C598.744 256 592.968 254.828 592.968 256.255C595.026 258.055 598.498 260.946 601.323 262.946C599.677 264.655 598.78 266.769 598.029 268.539C597.478 269.838 597.006 270.952 596.373 271.585C595.861 272.097 593.43 273.706 591.462 275.008L591.462 275.008C590.332 275.756 589.356 276.402 588.984 276.681C587.965 277.445 588.474 278.464 589.239 278.974C589.92 279.428 589.792 279.68 589.214 280.812C589.144 280.95 589.067 281.101 588.984 281.267C588.372 282.49 588.729 284.155 588.984 284.834C587.252 284.834 587.359 286.122 587.431 286.978C587.443 287.13 587.455 287.267 587.455 287.382C587.455 287.709 586.99 288.222 586.338 288.94L586.338 288.941L586.337 288.941C585.463 289.904 584.254 291.237 583.378 292.988C582.553 294.639 585.368 296.81 588.614 299.06L588.658 299.529C588.952 302.652 589.332 306.678 588.905 308.218C585.011 309.335 581.468 310.411 578.7 311.287C578.438 311.37 578.183 311.451 577.935 311.53C577.85 311.53 577.477 312.142 576.661 314.588C576.283 315.495 575.95 317.187 575.562 319.159L575.562 319.159C574.642 323.832 573.413 330.075 570.546 331.15C569.115 331.686 567.528 332.913 565.574 334.423C561.961 337.215 557.095 340.976 549.652 343.126C543.392 344.934 541.461 344.008 539.796 343.209C538.411 342.545 537.209 341.969 533.855 343.126C527.943 345.164 526.296 362.66 526.211 371.154C526.427 371.256 526.641 371.361 526.861 371.469C528.466 372.257 530.413 373.212 536 374.5C544.354 376.427 562.222 369.115 571.31 364.784C570.036 374.211 579.719 411.157 582.012 416.763C583.081 419.376 583.818 424.036 584.48 428.5L663.731 403.5C663.549 399.589 663.368 395.894 663.214 392.744L663.214 392.738C662.964 387.611 662.784 383.932 662.784 383.129C662.784 381.034 657.89 365.072 653.648 351.238L653.648 351.237C651.184 343.203 648.941 335.888 648.005 332.424C645.808 324.295 636.413 314.651 631.906 310.024C631.186 309.285 630.59 308.674 630.169 308.218C629.153 307.117 629.122 305.96 629.094 304.915C629.069 303.996 629.046 303.163 628.357 302.532C629.083 300.635 629.867 298.229 630.007 296.555C630.158 294.743 632.725 293.2 635.375 291.606C636.179 291.123 636.99 290.635 637.744 290.134Z',
            fill: ''
          }),
          React.createElement('path', {
            d: 'M496.208 257.336L503.392 255.768C500.664 253.934 501.208 250.594 501.821 249.153L500.925 245.047L493.512 246.729L494.637 250.721C496.547 251.822 496.48 255.59 496.208 257.336Z',
            fill: '#4B5361'
          }),
          React.createElement('path', {
            d: 'M505.072 263.75L503.393 255.767L496.208 257.336C495.925 261.931 499.026 271.864 513.692 274.835L514.609 273.243C511.536 272.396 505.325 269.312 505.072 263.75Z',
            fill: '#DAE4FA'
          }),
          React.createElement('path', {
            d: 'M510.551 261.036C509.645 259.665 509.425 257.423 509.429 256.473C507.946 256.734 504.664 256.957 503.392 255.767L505.072 263.75C505.872 263.069 508.088 261.573 510.551 261.036Z',
            fill: '#CDD6E6'
          }),
          React.createElement('path', {
            d: 'M509.429 256.473L531.906 251.878C531.673 253.161 532.354 254.798 533.132 256.105L510.552 261.036C509.645 259.665 509.425 257.423 509.429 256.473Z',
            fill: '#4B5361'
          }),
          React.createElement('path', {
            d: 'M572.013 249.639C573.734 246.227 571.129 242.115 570.22 241.428L532.468 250.747C532.16 251.069 531.983 251.454 531.906 251.878C531.672 253.161 532.353 254.798 533.131 256.105C533.476 256.685 533.84 257.2 534.152 257.59L572.013 249.639Z',
            fill: '#EE7E79'
          }),
          React.createElement('path', {
            d: 'M634.084 259.608C619.306 251.455 604.018 261.137 603.253 261.392C598.667 264.195 598.157 269.8 596.374 271.584C595.568 272.39 590.004 275.916 588.984 276.68C587.965 277.444 588.475 278.464 589.239 278.973C590.004 279.483 589.749 279.738 588.984 281.266C588.373 282.489 588.73 284.154 588.984 284.834C586.946 284.834 587.456 286.617 587.456 287.382C587.456 288.146 584.908 289.93 583.379 292.987C581.85 296.045 592.806 300.886 595.864 304.708C598.31 307.766 617.947 305.982 627.459 304.708C628.224 303.009 629.804 299 630.007 296.554C630.262 293.497 637.397 291.204 640.199 288.146C643.002 285.088 648.863 267.762 634.084 259.608Z',
            fill: '#EDC7C5'
          }),
          React.createElement('path', {
            opacity: '0.2',
            d: 'M620.997 301.338C632.972 301.083 627.112 304.905 630.17 308.217C633.227 311.53 645.458 322.995 648.006 332.423C650.554 341.851 662.784 379.816 662.784 383.128C662.784 386.441 665.842 438.675 664.313 439.694C662.784 440.713 588.637 441.987 586.853 439.694C585.07 437.401 584.305 422.368 582.012 416.762C579.719 411.156 570.037 374.21 571.311 364.783C562.223 369.114 544.354 376.426 536 374.5C529.645 373.034 528 372 526.211 371.153C526.296 362.659 527.944 345.163 533.855 343.125C541.244 340.577 538.187 346.437 549.653 343.125C561.119 339.812 566.469 332.678 570.546 331.149C574.623 329.62 575.387 317.645 576.661 314.587C577.477 312.141 577.851 311.53 577.935 311.53C578.183 311.45 578.438 311.369 578.7 311.286C581.469 310.41 585.012 309.334 588.905 308.217C589.756 305.148 587.405 292.212 588.905 296.212C590.105 299.412 606.221 299.429 614.554 302.037C617.047 301.628 619.247 301.375 620.997 301.338Z',
            fill: 'url(#paint1_linear)'
          }),
          React.createElement('path', {
            d: 'M581.757 359.432C576.865 361.878 573.039 363.726 571 365C570 369 575.897 409.373 579.719 415.998C583.541 422.622 584.05 434.598 584.305 435.872C584.56 437.146 590.421 436.382 592.459 436.382C603.161 436.891 661.255 422.368 664.058 415.998C666.861 409.628 665.077 383.383 664.058 378.797C663.039 374.21 652.337 336.245 649.789 330.385C647.241 324.524 633 302.999 627 301.999C619.982 300.83 617 300.999 610.5 300.999C622.5 305.499 623.545 314.077 632.972 318.154C651.063 334.207 642.145 351.788 636.285 360.961C630.424 370.134 615.901 378.032 600.103 375.484C587.465 373.446 582.607 363.934 581.757 359.432Z',
            fill: '#8A6564'
          }),
          React.createElement('path', {
            d: 'M605.454 265.172C603.619 265.172 596.366 259.227 592.969 256.254C592.969 254.827 598.744 255.999 601.632 256.764C602.227 256.254 603.67 255.235 604.69 255.235C605.964 255.235 605.454 253.706 613.862 248.61C622.271 243.514 635.52 244.278 646.732 256.254C657.943 268.23 650.044 283.518 648.77 285.301C647.496 287.085 647.496 287.595 647.751 289.378C648.006 291.162 645.458 290.907 646.732 292.691C648.006 294.474 647.751 295.493 645.458 295.493C643.623 295.493 628.556 282.583 621.252 276.129C615.391 260.076 607.747 265.172 605.454 265.172Z',
            fill: '#FFCB56'
          }),
          React.createElement(
            'defs',
            null,
            React.createElement(
              'linearGradient',
              {
                id: 'paint0_linear',
                x1: '558',
                y1: '297',
                x2: '557.5',
                y2: '435',
                gradientUnits: 'userSpaceOnUse'
              },
              React.createElement('stop', { stopColor: '#F4F8F6' }),
              React.createElement('stop', { offset: '1', stopColor: '#4D4D4D' })
            ),
            React.createElement(
              'linearGradient',
              {
                id: 'paint1_linear',
                x1: '595.317',
                y1: '295.452',
                x2: '595.317',
                y2: '440.979',
                gradientUnits: 'userSpaceOnUse'
              },
              React.createElement('stop', { stopColor: '#DAE4FA' }),
              React.createElement('stop', { offset: '1', stopColor: 'white' })
            )
          )
        ) : React.createElement(
          'div',
          null,
          iconData.d1 && iconData.d2 && iconData.d3 ? React.createElement(
            'svg',
            { width: size, height: size, viewBox: '0 0 24 24' },
            React.createElement('rect', {
              width: '24',
              height: '24',
              fill: backgroundColor,
              rx: borderRadius,
              ry: borderRadius
            }),
            React.createElement('path', {
              fillRule: 'evenodd',
              clipRule: 'evenodd',
              d: iconData.d1 ? iconData.d1 : '',
              fill: selectedTheme.secondaryColor
            }),
            React.createElement('path', {
              fillRule: 'evenodd',
              clipRule: 'evenodd',
              d: iconData.d2 ? iconData.d2 : '',
              fill: selectedTheme.secondaryColor
            }),
            React.createElement('path', {
              fillRule: 'evenodd',
              clipRule: 'evenodd',
              d: iconData.d3 ? iconData.d3 : '',
              fill: selectedTheme.primaryColor
            })
          ) : '',
          iconData.d1 && iconData.d2 && iconData.d3 === null ? React.createElement(
            'svg',
            { width: size, height: size, viewBox: '0 0 24 24' },
            React.createElement('rect', {
              width: '24',
              height: '24',
              fill: backgroundColor,
              rx: borderRadius,
              ry: borderRadius
            }),
            React.createElement('path', {
              fillRule: 'evenodd',
              clipRule: 'evenodd',
              d: iconData.d1 ? iconData.d1 : '',
              fill: selectedTheme.secondaryColor
            }),
            React.createElement('path', {
              fillRule: 'evenodd',
              clipRule: 'evenodd',
              d: iconData.d2 ? iconData.d2 : '',
              fill: selectedTheme.primaryColor
            })
          ) : '',
          iconData.d1 && iconData.d2 === null && iconData.d3 === null ? React.createElement(
            'svg',
            { width: size, height: size, viewBox: '0 0 24 24' },
            React.createElement('rect', {
              width: '24',
              height: '24',
              fill: backgroundColor,
              rx: borderRadius,
              ry: borderRadius
            }),
            React.createElement('path', {
              fillRule: 'evenodd',
              clipRule: 'evenodd',
              d: iconData.d1 ? iconData.d1 : '',
              fill: selectedTheme.primaryColor
            })
          ) : ''
        )
      );
    }
  }]);
  return Icons;
}(React.Component);

Icons.propTypes = {
  category: PropTypes.string,
  name: PropTypes.string,
  size: PropTypes.number,
  primaryColor: PropTypes.string,
  secondaryColor: PropTypes.string,
  backgroundColor: PropTypes.string,
  borderRadius: PropTypes.number,
  theme: PropTypes.number
};

Icons.defaultProps = {
  size: 50,
  category: 'simple',
  name: 'lock',
  primaryColor: '#000',
  secondaryColor: '#fff',
  backgroundColor: 'none',
  borderRadius: 0
};

var _API$default = config,
    ACCESS_TOKEN = _API$default.ACCESS_TOKEN,
    SPACE_ID = _API$default.SPACE_ID;

var Shape = function (_Component) {
  inherits(Shape, _Component);

  function Shape() {
    classCallCheck(this, Shape);
    return possibleConstructorReturn(this, (Shape.__proto__ || Object.getPrototypeOf(Shape)).apply(this, arguments));
  }

  createClass(Shape, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          category = _props.category,
          name = _props.name,
          primaryColor = _props.primaryColor,
          size = _props.size,
          secondaryColor = _props.secondaryColor,
          backgroundColor = _props.backgroundColor,
          borderRadius = _props.borderRadius,
          theme = _props.theme;


      return React.createElement(
        'div',
        null,
        this.props.type.toLowerCase() === 'illustration' || this.props.type.toLowerCase() === 'illustrations' ? React.createElement(Illustrations, {
          accessToken: ACCESS_TOKEN,
          spaceId: SPACE_ID,
          category: category,
          name: name,
          size: size ? size : 900,
          backgroundColor: backgroundColor,
          borderRadius: !borderRadius ? 0 : borderRadius,
          theme: theme,
          primaryColor: primaryColor,
          secondaryColor: secondaryColor
        }) : '',
        this.props.type.toLowerCase() === 'icon' || this.props.type.toLowerCase() === 'icons' ? React.createElement(Icons, {
          accessToken: ACCESS_TOKEN,
          spaceId: SPACE_ID,
          category: category,
          name: name,
          size: size ? size : 54,
          backgroundColor: backgroundColor,
          borderRadius: borderRadius,
          theme: theme,
          primaryColor: primaryColor,
          secondaryColor: secondaryColor
        }) : ''
      );
    }
  }]);
  return Shape;
}(Component);

Shape.propTypes = {
  category: PropTypes.string,
  name: PropTypes.string,
  size: PropTypes.number,
  primaryColor: PropTypes.string,
  secondaryColor: PropTypes.string,
  backgroundColor: PropTypes.string,
  borderRadius: PropTypes.number,
  theme: PropTypes.number
};


Shape.defaultProps = {
  type: 'icons',
  category: 'simple',
  name: 'lock',
  primaryColor: 'black',
  secondaryColor: '#f7f5f6',
  backgroundColor: 'none',
  borderRadius: 0
};

export default Shape;
//# sourceMappingURL=index.es.js.map
